unit ExifCcrExif;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.Menus, Vcl.StdCtrls, Vcl.ComCtrls,
  MyListView, Vcl.ExtCtrls,
  IniFiles, MyUtility, CCR.Exif, CCR.Exif.TiffUtils;

const
  FORM_WIDTH_SET       = 510;
  FORM_HEIGHT_SET      = 420;
  FORM_MAX             = 'MAX';
  FORM_MIN             = 'MIN';
  FORM_NORMAL          = 'NORMAL';
  LISTBOX3_WIDTH       = 385;

  EXIF_DATA_0          = '  ';
  EXIF_DATA_1          = 'ID';
  EXIF_DATA_2          = '';
  EXIF_DATA_3          = 'f[^';
  EXIF_DATA_4          = '  ';

  LIST_COLUM_WIDH_0    =  35;
  LIST_COLUM_WIDH_1    =  70;
  LIST_COLUM_WIDH_2    = 250;
  LIST_COLUM_WIDH_3    = 300;
  LIST_COLUM_WIDH_4    =  30;

type
  TFormExifCcrExif = class(TForm)
    Panel2: TPanel;
    ListView1: TMyListView;
    Memo1: TMemo;
    Panel1: TPanel;
    Label1: TLabel;
    MainMenu1: TMainMenu;
    MenuFile: TMenuItem;
    MenuQuit: TMenuItem;
    MenuSetting: TMenuItem;
    MenuWindowPosition: TMenuItem;

    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormResize(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);

    procedure WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo); message WM_GETMINMAXINFO;

    procedure MenuQuitClick(Sender: TObject);
    procedure MenuWindowPositionClick(Sender: TObject);

    procedure GetFunction(StrList: TStringList; var FunctionCode: Integer; var Key: Word; Shift: TShiftState);

    procedure GetValue(FileName: String; Sender: TObject);
    function  CheckJfifExifFile(FileName: String): Boolean;

    procedure ListView1ColumnClick(Sender: TObject; Column: TListColumn);

  private
    { Private 錾 }
    FormPosLeft: Integer;
    FormPosTop: Integer;
    FormPosWidth: Integer;
    FormPosHeight: Integer;
    FormPosRight: Integer;
    FormPosButtom: Integer;

    MonitorTop: Integer;
    MonitorLeft: Integer;
    MonitorRight: Integer;
    MonitorButtom: Integer;
    MonitorWidth: Integer;
    MonitorHeight: Integer;

    StrFormState: String;

    StrListExif: TStringList;
    StrListPropaty: TStringList;
    StrListCcr: TStringList;
    CsvList2: TStringList;

    iTogle: Integer;

  public
    { Public 錾 }

  end;

var
  FormExifCcrExif: TFormExifCcrExif;

implementation

uses
  Main;

{$R *.dfm}

function ItemSort1(Item1,Item2: TListItem; SortColumn: Integer): Integer; stdcall;
begin
  //\[gݒ
  case SortColumn of
    0:   Result := -lstrcmp(PChar(Item1.Caption),                PChar(Item2.Caption));
    else Result := -lstrcmp(PChar(Item1.SubItems[SortColumn-1]), PChar(Item2.SubItems[SortColumn-1]));
   end;
end;

function ItemSort2(Item1,Item2: TListItem; SortColumn: Integer): Integer; stdcall;
begin
  //\[gݒ
  case SortColumn of
    0:   Result :=  lstrcmp(PChar(Item1.Caption),                PChar(Item2.Caption));
    else Result :=  lstrcmp(PChar(Item1.SubItems[SortColumn-1]), PChar(Item2.SubItems[SortColumn-1]));
   end;
end;

procedure TFormExifCcrExif.FormClose(Sender: TObject; var Action: TCloseAction);
var
  IniFile: TIniFile;
begin
  //ۑ
  if FormMain.bFormPositionSave = TRUE then
  begin
    MenuWindowPositionClick(Sender);
  end;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));

  //ݒ
  IniFile.WriteInteger('ExifCrrListViewWidth',  '0',  ListView1.Columns[0].Width);
  IniFile.WriteInteger('ExifCrrListViewWidth',  '1',  ListView1.Columns[1].Width);
  IniFile.WriteInteger('ExifCrrListViewWidth',  '2',  ListView1.Columns[2].Width);
  IniFile.WriteInteger('ExifCrrListViewWidth',  '3',  ListView1.Columns[3].Width);
  IniFile.WriteInteger('ExifCrrListViewWidth',  '4',  ListView1.Columns[4].Width);

  //j
  IniFile.Free;

  //IMEIt
  SetImeMode(FormExifCcrExif.Handle, imClose);

  //tH[JX߂
  FormMain.SetFocus;
end;

procedure TFormExifCcrExif.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
;
end;

procedure TFormExifCcrExif.FormCreate(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //m
  StrListExif := TStringList.Create;
  StrListPropaty := TStringList.Create;
  StrListCcr := TStringList.Create;
  CsvList2 := TStringList.Create;

  //
  Label1.Caption := '';

  //
  Memo1.Visible := FALSE;
  Memo1.Align := alClient;

  //
  ListView1.Columns.Add.Caption := EXIF_DATA_0;
  ListView1.Columns.Add.Caption := EXIF_DATA_1;
  ListView1.Columns.Add.Caption := EXIF_DATA_2;
  ListView1.Columns.Add.Caption := EXIF_DATA_3;
  ListView1.Columns.Add.Caption := EXIF_DATA_4;
  ListView1.ViewStyle := vsReport;
  ListView1.RowSelect := TRUE;
  ListView1.MultiSelect := FALSE;
  ListView1.Align := alClient;
  ListView1.Visible := TRUE;
  ListView1.ReadOnly := TRUE;

//  FALSE:tH[JXړĂc
//  D7  FALSE
//  XE2 TRUE
  ListView1.HideSelection := TRUE;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));

  //tH[ʒu
  FormPosLeft   := IniFile.ReadInteger('FormExifCcrExif', 'Left',   0);
  FormPosTop    := IniFile.ReadInteger('FormExifCcrExif', 'Top',    0);
  FormPosWidth  := IniFile.ReadInteger('FormExifCcrExif', 'Width',  FORM_WIDTH_SET);
  FormPosHeight := IniFile.ReadInteger('FormExifCcrExif', 'Height', FORM_HEIGHT_SET);
  StrFormState  := IniFile.ReadString ('FormExifCcrExif', 'State',  FORM_NORMAL);
  FormPosRight  := FormPosLeft + FormPosWidth;
  FormPosButtom := FormPosTop  + FormPosHeight;

  //ݒ
  ListView1.Columns[ 0].Width := IniFile.ReadInteger('ExifCrrListViewWidth',  '0', LIST_COLUM_WIDH_0);
  ListView1.Columns[ 1].Width := IniFile.ReadInteger('ExifCrrListViewWidth',  '1', LIST_COLUM_WIDH_1);
  ListView1.Columns[ 2].Width := IniFile.ReadInteger('ExifCrrListViewWidth',  '2', LIST_COLUM_WIDH_2);
  ListView1.Columns[ 3].Width := IniFile.ReadInteger('ExifCrrListViewWidth',  '3', LIST_COLUM_WIDH_3);
  ListView1.Columns[ 4].Width := IniFile.ReadInteger('ExifCrrListViewWidth',  '4', LIST_COLUM_WIDH_4);

  //j
  IniFile.Free;

end;

procedure TFormExifCcrExif.FormDestroy(Sender: TObject);
begin
  //j
  StrListExif.Free;
  StrListPropaty.Free;
  StrListCcr.Free;
  CsvList2.Free;
end;

procedure TFormExifCcrExif.FormShow(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //FormłȂ̂ŁACreatełȂShowōs
  //FormKeyDowñCxgݒ肷
  FormExifCcrExif.KeyPreview := TRUE;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));

  //tH[ʒu
  FormPosLeft   := IniFile.ReadInteger('FormExifCcrExif', 'Left',   0);
  FormPosTop    := IniFile.ReadInteger('FormExifCcrExif', 'Top',    0);
  FormPosWidth  := IniFile.ReadInteger('FormExifCcrExif', 'Width',  FORM_WIDTH_SET);
  FormPosHeight := IniFile.ReadInteger('FormExifCcrExif', 'Height', FORM_HEIGHT_SET);
  StrFormState  := IniFile.ReadString ('FormExifCcrExif', 'State',  FORM_NORMAL);
  FormPosRight  := FormPosLeft + FormPosWidth;
  FormPosButtom := FormPosTop  + FormPosHeight;


  //ݒ
  ListView1.Columns[ 0].Width := IniFile.ReadInteger('ExifCrrListViewWidth',  '0', LIST_COLUM_WIDH_0);
  ListView1.Columns[ 1].Width := IniFile.ReadInteger('ExifCrrListViewWidth',  '1', LIST_COLUM_WIDH_1);
  ListView1.Columns[ 2].Width := IniFile.ReadInteger('ExifCrrListViewWidth',  '2', LIST_COLUM_WIDH_2);
  ListView1.Columns[ 3].Width := IniFile.ReadInteger('ExifCrrListViewWidth',  '3', LIST_COLUM_WIDH_3);
  ListView1.Columns[ 4].Width := IniFile.ReadInteger('ExifCrrListViewWidth',  '4', LIST_COLUM_WIDH_4);

  //j
  IniFile.Free;

  //GetSystemMetricst֐gpāCzʑŜ̃TCY擾
  MonitorTop    := GetSystemMetrics(SM_YVIRTUALSCREEN);
  MonitorLeft   := GetSystemMetrics(SM_XVIRTUALSCREEN);
  MonitorWidth  := GetSystemMetrics(SM_CXVIRTUALSCREEN);
  MonitorHeight := GetSystemMetrics(SM_CYVIRTUALSCREEN);
  MonitorRight  := MonitorLeft + MonitorWidth;
  MonitorButtom := MonitorTop  + MonitorHeight;

  //\ł ȌԂŕ\
  if ( (MonitorTop  <= FormPosTop  + FORM_TOP_SHIFT ) and (FormPosTop    <= MonitorButtom) ) and
     ( (MonitorTop  <= FormPosButtom                ) and (FormPosButtom <= MonitorButtom) ) and
     ( (MonitorLeft <= FormPosLeft + FORM_LEFT_SHIFT) and (FormPosLeft   <= MonitorRight ) ) and
     ( (MonitorLeft <= FormPosRight                 ) and (FormPosRight  <= MonitorRight ) ) then
  begin
    FormExifCcrExif.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end
  //ʓɕ\łȂ ftHgŕ\
  else
  begin
    FormExifCcrExif.SetBounds(0, 0 ,FORM_WIDTH_SET, FORM_HEIGHT_SET);
  end;

  //ő
  if StrFormState = FORM_MAX then
  begin
    FormExifCcrExif.WindowState := wsMaximized;
  end
  //ŏ
  else if StrFormState = FORM_MIN then
  begin
    FormExifCcrExif.WindowState := wsMinimized;
  end
  //W
  else
  begin
    //
  end;

  //IMEIt
  SetImeMode(FormExifCcrExif.Handle, imClose);

end;

procedure TFormExifCcrExif.FormResize(Sender: TObject);
begin
;
end;

procedure TFormExifCcrExif.WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
begin
  //ŏTCY
  with msg.MinMaxInfo^.ptMinTrackSize do
  begin
    x := FORM_WIDTH_SET;
    y := FORM_HEIGHT_SET;
  end;
  //őTCY
  with msg.MinMaxInfo^.ptMaxTrackSize do
  begin
    //
  end;
  //ő剻TCY
  with msg.MinMaxInfo^.ptMaxSize do
  begin
    //
  end;
end;

procedure TFormExifCcrExif.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
var
  iFunc1: Integer;
begin
  //@\擾
  GetFunction(FormMain.StrListKeyMain, iFunc1, Key, Shift);
  case iFunc1 of
    601 :  //I
      begin
        if FormMain.MenuExitEscape.Checked = TRUE then
        begin
          MenuQuitClick(Sender);
        end;
        key := 0;
      end;
    602 :  //I
      begin
        if FormMain.MenuExitKeyQ.Checked = TRUE then
        begin
          MenuQuitClick(Sender);
        end;
        key := 0;
      end;
  end;
end;

procedure TFormExifCcrExif.FormKeyPress(Sender: TObject; var Key: Char);
begin
  //
  key := #0;
end;

procedure TFormExifCcrExif.ListView1ColumnClick(Sender: TObject; Column: TListColumn);
begin
  //\[g̔]
  iTogle := (iTogle+1) mod 2;
  if iTogle = 0 then
  begin
    ListView1.CustomSort(@ItemSort2, Column.Index);
  end
  else
  begin
    ListView1.CustomSort(@ItemSort1, Column.Index);
  end;
end;

procedure TFormExifCcrExif.MenuQuitClick(Sender: TObject);
begin
  //I
  Close;
end;

procedure TFormExifCcrExif.MenuWindowPositionClick(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));

  //ʏ
  if WindowState = wsMaximized then
  begin
    IniFile.WriteString ('FormExifCcrExif', 'State', FORM_MAX);
  end
  else if WindowState = wsMinimized then
  begin
    IniFile.WriteString ('FormExifCcrExif', 'State', FORM_MIN);
  end
  else
  begin
    IniFile.WriteString ('FormExifCcrExif', 'State', FORM_NORMAL);
    //ʃTCY
    IniFile.WriteInteger('FormExifCcrExif', 'Left',   FormExifCcrExif.Left);
    IniFile.WriteInteger('FormExifCcrExif', 'Top',    FormExifCcrExif.Top);
    IniFile.WriteInteger('FormExifCcrExif', 'Width',  FormExifCcrExif.Width);
    IniFile.WriteInteger('FormExifCcrExif', 'Height', FormExifCcrExif.Height);
  end;

  //j
  IniFile.Free;
end;


procedure TFormExifCcrExif.GetValue(FileName: String; Sender: TObject);

function ResolutionUnitsToStr(Value: TTiffResolutionUnit): string;
begin
  case Value of
    trNone:       Result := '';
    trInch:       Result := 'inches';
    trCentimetre: Result := 'centimetres';
  else Result := '---';
  end;
end;

function DegMinSecToStr(value: String): string;
var
  sStr1: String;
  sStr2: String;
  sStr3: String;
  sStr4: String;
  sStr5: String;
  sStr6: String;
  sStr7: String;
  sStr8: String;
  sStr9: String;
  sStr10: String;
  sStr11: String;
  sStr12: String;
  sStr13: String;
  iPos1: Integer;
  iPos2: Integer;
  iPos3: Integer;
  iPos4: Integer;
begin
  try
    sStr1 := value;//34,1234/100,0N
    iPos1 := Pos(',', sStr1);
    sStr2 := Copy(sStr1, 1, iPos1-1);//34

    sStr3 := Copy(sStr1, iPos1+1, Length(sStr1));//1234/100,0N
    iPos2 := Pos(',', sStr3);
    sStr4 := Copy(sStr3, 1, iPos2-1);//1234/100
    iPos3 := Pos('/', sStr4);
    if iPos3 > 0 then
    begin
      sStr5 := Copy(sStr4, 1, iPos3-1);//1234
      sStr6 := Copy(sStr4, iPos3+1, Length(sStr4));//100
      sStr7 := FloatToStr(StrToFloat(sStr5) / StrToFloat(sstr6));
    end
    else
    begin
      sStr7 := sStr4;
    end;

    sStr8 := Copy(sStr3, iPos2+1, Length(sStr3));//0N
    sStr9 := Copy(sStr8, 1, Length(sStr8)-1);//0
    iPos4 := Pos('/', sStr9);
    if iPos4 > 0 then
    begin
      sStr10 := Copy(sStr8, 1, iPos4-1);//
      sStr11 := Copy(sStr8, iPos4+1, Length(sStr8));//
      sStr12 := FloatToStr(StrToFloat(sStr5) / StrToFloat(sstr5));
    end
    else
    begin
      sStr12 := sStr9;
    end;

    if UpperCase(Copy(value, Length(value), 1)) = UpperCase('N') then
    begin
      sStr13 := 'North';
    end;
    if UpperCase(Copy(value, Length(value), 1)) = UpperCase('E') then
    begin
      sStr13 := 'East ';
    end;
    if UpperCase(Copy(value, Length(value), 1)) = UpperCase('W') then
    begin
      sStr13 := 'West ';
    end;
    if UpperCase(Copy(value, Length(value), 1)) = UpperCase('S') then
    begin
      sStr13 := 'South';
    end;
    Result := sStr13 + ' ' + sStr2 + 'deg' + ' ' + sStr7 + 'min' + ' ' + sStr12 + 'sec'
  except
    Result := '---';
  end;
end;

var
  ExifData1: TExifData;
  sStr1: String;
  sStr2: String;
  sStr3: String;
  iPos1: Integer;

  nItem: TListItem;
  sValue: String;
  iRow1: Integer;
  StrList1: TStringList;
  StrList2: TStringList;
  CsvList91: TStringList;
  CsvList92: TStringList;
  CsvList93: TStringList;
begin
  //
  Label1.Caption := ExtractFileName(FileName);

  //\Ȃ牽Ȃ
  if FormExifCcrExif.Visible = FALSE then
  begin
    Exit;
  end;

  //NA
  ListView1.Items.BeginUpdate;
  ListView1.Items.Clear;
  ListView1.Items.EndUpdate;

  //m
  StrList1 := TStringList.Create;
  StrList2 := TStringList.Create;
  CsvList91 := TStringList.Create;
  CsvList92 := TStringList.Create;
  CsvList93 := TStringList.Create;

  //JpgłȂ
  if CheckJfifExifFile(FileName) = FALSE then
  begin
    //
    ShowMessage('Information : JPG(JFIF) ܂ JPG(Exif) ̃t@Cł͂܂B');
    //ۑ
    StrList1.SaveToFile   (ExtractFilePath(ParamStr(0)) + EXIF_TXT);
  end
  //Jpg
  else
  begin
    //ݒ
    StrListCcr.Clear;

    StrListCcr.Add(EXIF_DATA_0 + #09 + '$010F' + #09 + 'CameraMake');
    StrListCcr.Add(EXIF_DATA_0 + #09 + '$0110' + #09 + 'CameraModel');//01
    StrListCcr.Add(EXIF_DATA_0 + #09 + '$8298' + #09 + 'Copyright');
    StrListCcr.Add(EXIF_DATA_0 + #09 + '$0132' + #09 + 'DateTime');
    StrListCcr.Add(EXIF_DATA_0 + #09 + '$0112' + #09 + 'Orientation');
    StrListCcr.Add(EXIF_DATA_0 + #09 + '     ' + #09 + 'Resolution');

    StrListCcr.Add(EXIF_DATA_0 + #09 + '$0131' + #09 + 'Software');//06
    StrListCcr.Add(EXIF_DATA_0 + #09 + '$9C9D' + #09 + 'Author');
    StrListCcr.Add(EXIF_DATA_0 + #09 + '$9C9C' + #09 + 'Comments');
    StrListCcr.Add(EXIF_DATA_0 + #09 + '$9C9E' + #09 + 'Keywords');
    StrListCcr.Add(EXIF_DATA_0 + #09 + '$9C9F' + #09 + 'Subject');

    StrListCcr.Add(EXIF_DATA_0 + #09 + '$9C9B' + #09 + 'Title');//11
    StrListCcr.Add(EXIF_DATA_0 + #09 + '$9000' + #09 + 'ExifVersion');
    StrListCcr.Add(EXIF_DATA_0 + #09 + '$9202' + #09 + 'ApertureValue');
    StrListCcr.Add(EXIF_DATA_0 + #09 + '$A431' + #09 + 'BodySerialNumber');
    StrListCcr.Add(EXIF_DATA_0 + #09 + '$9203' + #09 + 'BrightnessValue');


    StrListCcr.Add(EXIF_DATA_0 + #09 + '$A430' + #09 + 'CameraOwnerName');//16
    StrListCcr.Add(EXIF_DATA_0 + #09 + '$A001' + #09 + 'ColorSpace');
    StrListCcr.Add(EXIF_DATA_0 + #09 + '$A408' + #09 + 'Contrast');
    StrListCcr.Add(EXIF_DATA_0 + #09 + '$9102' + #09 + 'CompressedBitsPerPixel');
    StrListCcr.Add(EXIF_DATA_0 + #09 + '$9003' + #09 + 'DateTimeOriginal');

    StrListCcr.Add(EXIF_DATA_0 + #09 + '$9004' + #09 + 'DateTimeDigitized');//21
    StrListCcr.Add(EXIF_DATA_0 + #09 + '$A404' + #09 + 'DigitalZoomRatio');
    StrListCcr.Add(EXIF_DATA_0 + #09 + '$A002' + #09 + 'ExifImageWidth');
    StrListCcr.Add(EXIF_DATA_0 + #09 + '$A003' + #09 + 'ExifImageHeight');
    StrListCcr.Add(EXIF_DATA_0 + #09 + '$9204' + #09 + 'ExposureBiasValue');

    StrListCcr.Add(EXIF_DATA_0 + #09 + '$A215' + #09 + 'ExposureIndex');//26
    StrListCcr.Add(EXIF_DATA_0 + #09 + '$A402' + #09 + 'ExposureMode');
    StrListCcr.Add(EXIF_DATA_0 + #09 + '$8822' + #09 + 'ExposureProgram');
    StrListCcr.Add(EXIF_DATA_0 + #09 + '$829A' + #09 + 'ExposureTime');
    StrListCcr.Add(EXIF_DATA_0 + #09 + '$A300' + #09 + 'FileSource');

    StrListCcr.Add(EXIF_DATA_0 + #09 + '$9209' + #09 + 'Flash-Present');//31
    StrListCcr.Add(EXIF_DATA_0 + #09 + '$829D' + #09 + 'FNumber');
    StrListCcr.Add(EXIF_DATA_0 + #09 + '$920A' + #09 + 'FocalLength');
    StrListCcr.Add(EXIF_DATA_0 + #09 + '$A405' + #09 + 'FocalLengthIn35mmFilm');
    StrListCcr.Add(EXIF_DATA_0 + #09 + '     ' + #09 + 'FocalPlaneResolution');

    StrListCcr.Add(EXIF_DATA_0 + #09 + '$A407' + #09 + 'GainControl');//36
    StrListCcr.Add(EXIF_DATA_0 + #09 + '$A420' + #09 + 'ImageUniqueID');
    StrListCcr.Add(EXIF_DATA_0 + #09 + '$8827' + #09 + 'ISOSpeedRatings');
    StrListCcr.Add(EXIF_DATA_0 + #09 + '$A433' + #09 + 'LensMake');
    StrListCcr.Add(EXIF_DATA_0 + #09 + '$A434' + #09 + 'LensModel');

    StrListCcr.Add(EXIF_DATA_0 + #09 + '$9208' + #09 + 'LightSource');//41
    StrListCcr.Add(EXIF_DATA_0 + #09 + '$9205' + #09 + 'MaxApertureValue');
    StrListCcr.Add(EXIF_DATA_0 + #09 + '$9207' + #09 + 'MeteringMode');
    StrListCcr.Add(EXIF_DATA_0 + #09 + '$EA1D' + #09 + 'OffsetSchema');
    StrListCcr.Add(EXIF_DATA_0 + #09 + '$A004' + #09 + 'RelatedSoundFile');

    StrListCcr.Add(EXIF_DATA_0 + #09 + '$A401' + #09 + 'Rendering');//46
    StrListCcr.Add(EXIF_DATA_0 + #09 + '$A409' + #09 + 'Saturation');
    StrListCcr.Add(EXIF_DATA_0 + #09 + '$A406' + #09 + 'SceneCaptureType');
    StrListCcr.Add(EXIF_DATA_0 + #09 + '$A301' + #09 + 'SceneType');
    StrListCcr.Add(EXIF_DATA_0 + #09 + '$A217' + #09 + 'SensingMethod');

    StrListCcr.Add(EXIF_DATA_0 + #09 + '$A40A' + #09 + 'Sharpness');//51
    StrListCcr.Add(EXIF_DATA_0 + #09 + '$9201' + #09 + 'ShutterSpeedValue');
    StrListCcr.Add(EXIF_DATA_0 + #09 + '$8824' + #09 + 'SpectralSensitivity');
    StrListCcr.Add(EXIF_DATA_0 + #09 + '$9206' + #09 + 'SubjectDistance');
    StrListCcr.Add(EXIF_DATA_0 + #09 + '$A40C' + #09 + 'SubjectDistanceRange');

    StrListCcr.Add(EXIF_DATA_0 + #09 + '$A214' + #09 + 'SubjectLocation');//56
    StrListCcr.Add(EXIF_DATA_0 + #09 + '$A403' + #09 + 'WhiteBalanceMode');
    StrListCcr.Add(EXIF_DATA_0 + #09 + '$9290' + #09 + 'SubsecTime');
    StrListCcr.Add(EXIF_DATA_0 + #09 + '$9291' + #09 + 'SubsecTimeOriginal');
    StrListCcr.Add(EXIF_DATA_0 + #09 + '$9292' + #09 + 'SubsecTimeDigitized');

    StrListCcr.Add(EXIF_DATA_0 + #09 + '$0001' + #09 + 'InteropTypeName');//61
    StrListCcr.Add(EXIF_DATA_0 + #09 + '$0002' + #09 + 'InteropVersion');
    StrListCcr.Add(EXIF_DATA_0 + #09 + '$0000' + #09 + 'GPSVersion');
    StrListCcr.Add(EXIF_DATA_0 + #09 + '$0002' + #09 + 'GPSLatitude');
    StrListCcr.Add(EXIF_DATA_0 + #09 + '$0004' + #09 + 'GPSLongitude');

    StrListCcr.Add(EXIF_DATA_0 + #09 + '$0005' + #09 + 'GPSAltitudeRef');//66
    StrListCcr.Add(EXIF_DATA_0 + #09 + '$0006' + #09 + 'GPSAltitude');
    StrListCcr.Add(EXIF_DATA_0 + #09 + '$0008' + #09 + 'GPSSatellites');
    StrListCcr.Add(EXIF_DATA_0 + #09 + '$0009' + #09 + 'GPSStatus');
    StrListCcr.Add(EXIF_DATA_0 + #09 + '$000A' + #09 + 'GPSMeasureMode');

    StrListCcr.Add(EXIF_DATA_0 + #09 + '$000B' + #09 + 'GPSDOP');//71
    StrListCcr.Add(EXIF_DATA_0 + #09 + '$000C' + #09 + 'GPSSpeedRef');
    StrListCcr.Add(EXIF_DATA_0 + #09 + '$000D' + #09 + 'GPSSpeed');
    StrListCcr.Add(EXIF_DATA_0 + #09 + '$000E' + #09 + 'GPSTrackRef');
    StrListCcr.Add(EXIF_DATA_0 + #09 + '$000F' + #09 + 'GPSTrack');

    StrListCcr.Add(EXIF_DATA_0 + #09 + '$0010' + #09 + 'GPSImgDirectionRef');//76
    StrListCcr.Add(EXIF_DATA_0 + #09 + '$0011' + #09 + 'GPSImgDirection');
    StrListCcr.Add(EXIF_DATA_0 + #09 + '$0012' + #09 + 'GPSMapDatum');
    StrListCcr.Add(EXIF_DATA_0 + #09 + '$0014' + #09 + 'GPSDestLatitude');
    StrListCcr.Add(EXIF_DATA_0 + #09 + '$0016' + #09 + 'GPSDestLongitude');

    StrListCcr.Add(EXIF_DATA_0 + #09 + '$0017' + #09 + 'GPSDestBearingRef');//81
    StrListCcr.Add(EXIF_DATA_0 + #09 + '$0018' + #09 + 'GPSDestBearing');
    StrListCcr.Add(EXIF_DATA_0 + #09 + '$0019' + #09 + 'GPSDestDistanceRef');
    StrListCcr.Add(EXIF_DATA_0 + #09 + '$001A' + #09 + 'GPSDestDistance');
    StrListCcr.Add(EXIF_DATA_0 + #09 + '$001E' + #09 + 'GPSDifferential');

    StrListCcr.Add(EXIF_DATA_0 + #09 + '     ' + #09 + 'GPSDateTimeUTC');//86
    StrListCcr.Add(EXIF_DATA_0 + #09 + '$001D' + #09 + 'GPSDateStamp');
    StrListCcr.Add(EXIF_DATA_0 + #09 + '     ' + #09 + 'GPSTimeStampHour');
    StrListCcr.Add(EXIF_DATA_0 + #09 + '     ' + #09 + 'GPSTimeStampMinute');
    StrListCcr.Add(EXIF_DATA_0 + #09 + '     ' + #09 + 'GPSTimeStampSecond');

    StrListCcr.Add(EXIF_DATA_0 + #09 + '     ' + #09 + 'ThumbnailOrientation');//91
    StrListCcr.Add(EXIF_DATA_0 + #09 + '     ' + #09 + 'ThumbnailResolution');

    //
    ExifData1 := TExifData.Create;
    try
      //Ǎ
      ExifData1.LoadFromGraphic(FileName);

      try
        sStr1 := '---';
      except
        sStr1 := '---';
      end;
      //vpeB
      try
        sStr1  := ExifData1.CameraMake;
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[ 0] + #09 + sStr1);

      try
        sStr1 := ExifData1.CameraModel;
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[ 1] + #09 + sStr1);

      try
        sStr1 := ExifData1.Copyright;
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[ 2] + #09 + sStr1);

      try
        DateTimeToString(sStr1, 'yyyy-MM-dd HH:mm:ss', ExifData1.DateTime);
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[ 3] + #09 + sStr1);

      try
        if ExifData1.Orientation = toUndefined then
        begin
          sStr1 := '';
        end
        else if ExifData1.Orientation = toTopLeft then
        begin
          sStr1 := 'Normal';
        end
       else if ExifData1.Orientation = toTopRight then
         begin
          sStr1 := 'Mirror horizontal';
        end
        else if ExifData1.Orientation = toBottomRight then
        begin
          sStr1 := 'Rotate 180';
        end
        else if ExifData1.Orientation = toBottomLeft then
        begin
          sStr1 := 'Mirror vertical';
        end
        else if ExifData1.Orientation = toLeftTop then
        begin
          sStr1 := 'Mirror horizontal and rotate 270';
        end
        else if ExifData1.Orientation = toRightTop then
        begin
          sStr1 := 'Rotate 90';
        end
        else if ExifData1.Orientation = toRightBottom then
        begin
          sStr1 := 'Mirror hotizontal and rotate 90';
        end
        else if ExifData1.Orientation = toLeftBottom then
        begin
          sStr1 := 'Rotate 270';
        end
        else
        begin
          sStr1 := 'Undefined';
        end;
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[ 4] + #09 + sStr1);

      try
        //    property X: TExifFraction read GetX write SetX stored False;
        //    property Y: TExifFraction read GetY write SetY stored False;
        //    property Units: TExifResolutionUnit read GetUnit write SetUnit stored False;
        sStr1 := FloatToStr(ExifData1.Resolution.X.Quotient);
        sStr2 := FloatToStr(ExifData1.Resolution.Y.Quotient);
      except
        sStr1 := '---';
        sStr2 := '---';
      end;
      try
        if ExifData1.Resolution.Units = trNone then
        begin
          sStr3 := 'None';
        end
        else if ExifData1.Resolution.Units = trInch then
        begin
          sStr3 := 'Inch';
        end
        else if ExifData1.Resolution.Units = trCentimetre then
        begin
          sStr3 := 'Centimetre';
        end
        else
        begin
          sStr3 := 'Undefined';
        end;
      except
        sStr3 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[ 5] + #09 + 'X=' + sStr1 + ' ' + 'Y=' + sStr2 + ' '  + sStr3);

      try
        sStr1 := ExifData1.Software;
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[ 6] + #09 + sStr1);

      try
        sStr1 := ExifData1.Author;
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[ 7] + #09 + sStr1);

      try
        sStr1 := ExifData1.Comments;
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[ 8] + #09 + sStr1);

      try
        sStr1 := ExifData1.Keywords;
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[ 9] + #09 + sStr1);

      try
        sStr1 := ExifData1.Subject;
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[10] + #09 + sStr1);

      try
        sStr1 := ExifData1.Title;
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[11] + #09 + sStr1);

      try
        sStr1 := ExifData1.ExifVersion.AsString;
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[12] + #09 + sStr1);

      try
        iPos1 := Pos('/', ExifData1.ApertureValue.AsString);
        sStr1 := Copy(ExifData1.ApertureValue.AsString, 1,       iPos1-1);
        sStr2 := Copy(ExifData1.ApertureValue.AsString, iPos1+1, Length(ExifData1.ApertureValue.AsString));
        if (sStr1 = '') or (sStr2 = '') then
        begin
          sStr3 := '';
        end
        else
        begin
          sStr3 := FloatToStr(StrToFloat(sStr1) / StrToFloat(sStr2));
        end;
      except
        sStr3 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[13] + #09 + sStr3);

      try
        sStr1 := ExifData1.BodySerialNumber;
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[14] + #09 + sStr1);

      try
        iPos1 := Pos('/', ExifData1.BrightnessValue.AsString);
        sStr1 := Copy(ExifData1.BrightnessValue.AsString, 1,       iPos1-1);
        sStr2 := Copy(ExifData1.BrightnessValue.AsString, iPos1+1, Length(ExifData1.BrightnessValue.AsString));
        if (sStr1 = '') or (sStr2 = '') then
        begin
          sStr3 := '';
        end
        else
        begin
          sStr3 := FloatToStr(StrToFloat(sStr1) / StrToFloat(sStr2));
        end;
      except
        sStr3 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[15] + #09 + sStr3);

      try
        sStr1 := ExifData1.CameraOwnerName;
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[16] + #09 + sStr1);

      try
        if ExifData1.ColorSpace = csTagMissing then
        begin
          sStr1 := '';
        end
        else if ExifData1.ColorSpace = csRGB then
        begin
          sStr1 := 'sRGB';
        end
        else if ExifData1.ColorSpace = csAdobeRGB then
        begin
          sStr1 := 'Adobe RGB';
        end
        else if ExifData1.ColorSpace = csWideGamutRGB then
        begin
          sStr1 := 'Wide gamut RGB (Sony)';
        end
        else if ExifData1.ColorSpace = csICCProfile then
        begin
          sStr1 := 'ICC profile (Sony)';
        end
        else if ExifData1.ColorSpace = csUncalibrated then
        begin
          sStr1 := 'Uncalibrated (maybe Adobe RGB)';
        end
        else
        begin
          sStr1 := 'Undefined';
        end;
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[17] + #09 + sStr1);

      try
        if ExifData1.Contrast = cnTagMissing then
        begin
          sStr1 := '';
        end
        else if ExifData1.Contrast = cnNormal then
        begin
          sStr1 := 'Normal';
        end
        else if ExifData1.Contrast = cnSoft then
        begin
          sStr1 := 'Soft';
        end
        else if ExifData1.Contrast = cnHard then
        begin
          sStr1 := 'Hard';
        end
        else
        begin
          sStr1 := 'Undefined';
        end;
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[18] + #09 + sStr1);

      try
        sStr1 := ExifData1.CompressedBitsPerPixel.AsString;
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[19] + #09 + sStr1);

      try
        DateTimeToString(sStr1, 'yyyy-MM-dd HH:mm:ss', ExifData1.DateTimeOriginal);
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[20] + #09 + sStr1);

      try
        DateTimeToString(sStr1, 'yyyy-MM-dd HH:mm:ss', ExifData1.DateTimeDigitized);
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[21] + #09 + sStr1);

      try
        sStr1 := ExifData1.DigitalZoomRatio.AsString;
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[22] + #09 + sStr1);

      try
        sStr1 := InttoStr(ExifData1.ExifImageWidth);
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[23] + #09 + sStr1);

      try
        sStr1 := InttoStr(ExifData1.ExifImageHeight);
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[24] + #09 + sStr1);

      try
        sStr1 := ExifData1.ExposureBiasValue.AsString;
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[25] + #09 + sStr1);

      try
        sStr1 := ExifData1.ExposureIndex.AsString;
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[26] + #09 + sStr1);

      try
        if ExifData1.ExposureMode = exTagMissing then
        begin
          sStr1 := '';
        end
        else if ExifData1.ExposureMode = exAuto then
        begin
          sStr1 := 'Auto';
        end
        else if ExifData1.ExposureMode = exManual then
        begin
          sStr1 := 'Manual';
        end
        else if ExifData1.ExposureMode = exAutoBracket then
        begin
          sStr1 := 'Auto Bracket';
        end
        else
        begin
          sStr1 := 'Undefined';
        end;
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[27] + #09 + sStr1);

      try
        if ExifData1.ExposureProgram = eeTagMissing then
        begin
          sStr1 := '';
        end
        else if ExifData1.ExposureProgram = eeUndefined then
        begin
          sStr1 := 'Undefined';
        end
        else if ExifData1.ExposureProgram = eeManual then
        begin
          sStr1 := 'Manual';
        end
        else if ExifData1.ExposureProgram = eeNormal then
        begin
          sStr1 := 'Normal';
        end
        else if ExifData1.ExposureProgram = eeAperturePriority then
        begin
          sStr1 := 'Aperture Priority';
        end
        else if ExifData1.ExposureProgram = eeShutterPriority then
        begin
          sStr1 := 'Shutter Priority';
        end
        else if ExifData1.ExposureProgram = eeCreative then
        begin
          sStr1 := 'Creative';
        end
        else if ExifData1.ExposureProgram = eeAction then
        begin
          sStr1 := 'Action';
        end
        else if ExifData1.ExposureProgram = eePortrait then
        begin
          sStr1 := 'Portrait';
        end
        else if ExifData1.ExposureProgram = eeLandscape then
        begin
          sStr1 := 'Landscape';
        end
        else
        begin
          sStr1 := 'Undefined';
        end;
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[28] + #09 + sStr1);

      try
        iPos1 := Pos('/', ExifData1.ExposureTime.AsString);
        sStr1 := Copy(ExifData1.ExposureTime.AsString, 1,       iPos1-1);
        sStr2 := Copy(ExifData1.ExposureTime.AsString, iPos1+1, Length(ExifData1.ExposureTime.AsString));
        if (sStr1 = '') or (sStr2 = '') then
        begin
          sStr3 := '';
        end
        else
        begin
          sStr3 := FloatToStr(StrToFloat(sStr1) / StrToFloat(sStr2));
        end;
      except
        sStr3 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[29] + #09 + sStr3 + 'sec');

      try
        if ExifData1.FileSource = fsUnknown then
        begin
          sStr1 := '';
        end
        else if ExifData1.FileSource = fsFilmScanner then
        begin
          sStr1 := 'FilmScanner';
        end
        else if ExifData1.FileSource = fsReflectionPrintScanner then
        begin
          sStr1 := 'Reflection PrintScanner';
        end
        else if ExifData1.FileSource = fsDigitalCamera then
        begin
          sStr1 := 'Digital Camera';
        end
        else
        begin
          sStr1 := 'Undefined';
        end;
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[30] + #09 + sStr1);

      try
        if ExifData1.Flash.Present = TRUE then
        begin
          sStr1 := 'On';
        end
        else
        begin
          sStr1 := 'Off';
        end;
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[31] + #09 + sStr1);

      try
        iPos1 := Pos('/', ExifData1.FNumber.AsString);
        sStr1 := Copy(ExifData1.FNumber.AsString, 1,       iPos1-1);
        sStr2 := Copy(ExifData1.FNumber.AsString, iPos1+1, Length(ExifData1.FNumber.AsString));
        if (sStr1 = '') or (sStr2 = '') then
        begin
          sStr3 := '';
        end
        else
        begin
          sStr3 := FloatToStr(StrToFloat(sStr1) / StrToFloat(sStr2));
        end;
      except
        sStr3 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[32] + #09 + sStr3);

      try
        iPos1 := Pos('/', ExifData1.FocalLength.AsString);
        sStr1 := Copy(ExifData1.FocalLength.AsString, 1,       iPos1-1);
        sStr2 := Copy(ExifData1.FocalLength.AsString, iPos1+1, Length(ExifData1.FocalLength.AsString));
        if (sStr1 = '') or (sStr2 = '') then
        begin
          sStr3 := '';
        end
        else
        begin
          sStr3 := FloatToStr(StrToFloat(sStr1) / StrToFloat(sStr2));
        end;
      except
        sStr3 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[33] + #09 + sStr3);

      try
        sStr1 := ExifData1.FocalLengthIn35mmFilm.AsString;
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[34] + #09 + sStr1);

      try
        sStr1 := Format('%g x %g %s', [ExifData1.Resolution.X.Quotient,
                                       ExifData1.Resolution.Y.Quotient,
                                       ResolutionUnitsToStr(ExifData1.Resolution.Units)]);
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[35] + #09 + sStr1); //FocalPlaneResolution

      try
        if ExifData1.GainControl = egTagMissing then
        begin
          sStr1 := '';
        end
        else if ExifData1.GainControl = egNone then
        begin
          sStr1 := 'None';
        end
        else if ExifData1.GainControl = egLowGainUp then
        begin
          sStr1 := 'Low Gain Up';
        end
        else if ExifData1.GainControl = egHighGainUp then
        begin
          sStr1 := 'High Gain Up';
        end
        else if ExifData1.GainControl = egLowGainDown then
        begin
          sStr1 := 'Low Gain Down';
        end
        else if ExifData1.GainControl = egHighGainDown then
        begin
          sStr1 := 'High Gain Down';
        end
        else
        begin
          sStr1 := 'Undefined';
        end;
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[36] + #09 + sStr1);

      try
        sStr1 := ExifData1.ImageUniqueID;
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[37] + #09 + sStr1);

      try
        sStr1 := ExifData1.ISOSpeedRatings.AsString;
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[38] + #09 + sStr1);

      try
        sStr1 := ExifData1.LensMake;
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[39] + #09 + sStr1);

      try
        sStr1 := ExifData1.LensModel;
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[40] + #09 + sStr1);

      try
        if ExifData1.LightSource = elTagMissing then
        begin
          sStr1 := '';
        end
        else if ExifData1.LightSource = elUnknown then
        begin
          sStr1 := 'Unknown';
        end
        else if ExifData1.LightSource = elDaylight then
        begin
          sStr1 := 'Daylight';
        end
        else if ExifData1.LightSource = elFluorescent then
        begin
          sStr1 := 'Fluorescent';
        end
        else if ExifData1.LightSource = elTungsten then
        begin
          sStr1 := 'Tungsten';
        end
        else if ExifData1.LightSource = elFlash then
        begin
          sStr1 := 'Flash';
        end
        else if ExifData1.LightSource = elFineWeather then
        begin
          sStr1 := 'Fine Weather';
        end
        else if ExifData1.LightSource = elCloudyWeather then
        begin
          sStr1 := 'Cloudy Weather';
        end
        else if ExifData1.LightSource = elShade then
        begin
          sStr1 := 'Shade';
        end
        else if ExifData1.LightSource = elDaylightFluorescent then
        begin
          sStr1 := 'Day light Fluorescent';
        end
        else if ExifData1.LightSource = elDayWhiteFluorescent then
        begin
          sStr1 := 'Day White Fluorescent';
        end
        else if ExifData1.LightSource = elCoolWhiteFluorescent then
        begin
          sStr1 := 'Cool White Fluorescent';
        end
        else if ExifData1.LightSource = elWhiteFluorescent then
        begin
          sStr1 := 'White Fluorescent';
        end
        else if ExifData1.LightSource = elStandardLightA then
        begin
          sStr1 := 'Standard Light A';
        end
        else if ExifData1.LightSource = elStandardLightB then
        begin
          sStr1 := 'Standard Light B';
        end
        else if ExifData1.LightSource = elStandardLightC then
        begin
          sStr1 := 'Standard Light C';
        end
        else if ExifData1.LightSource = elD55 then
        begin
          sStr1 := 'D55';
        end
        else if ExifData1.LightSource = elD65 then
        begin
          sStr1 := 'D65';
        end
        else if ExifData1.LightSource = elD75 then
        begin
          sStr1 := 'D75';
        end
        else if ExifData1.LightSource = elD50 then
        begin
          sStr1 := 'D50';
        end
        else if ExifData1.LightSource = elISOStudioTungsten then
        begin
          sStr1 := 'ISO Studio Tungsten';
        end
        else if ExifData1.LightSource = elOther then
        begin
          sStr1 := 'Other';
        end
        else
        begin
          sStr1 := 'Undefined';
        end;
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[41] + #09 + sStr1);

      try
        sStr1 := ExifData1.MaxApertureValue.AsString;
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[42] + #09 + sStr1);

      try
        if ExifData1.MeteringMode = emTagMissing then
        begin
          sStr1 := '';
        end
        else if ExifData1.MeteringMode = emUnknown then
        begin
          sStr1 := 'Unknown';
        end
        else if ExifData1.MeteringMode = emAverage then
        begin
          sStr1 := 'Average';
        end
        else if ExifData1.MeteringMode = emCenterWeightedAverage then
        begin
          sStr1 := 'Center Weighted Average';
        end
        else if ExifData1.MeteringMode = emSpot then
        begin
          sStr1 := 'Spot';
        end
        else if ExifData1.MeteringMode = emMultiSpot then
        begin
          sStr1 := 'Multi Spot';
        end
        else if ExifData1.MeteringMode = emPattern then
        begin
          sStr1 := 'Pattern';
        end
        else if ExifData1.MeteringMode = emPartial then
        begin
          sStr1 := 'Partial';
        end
        else
        begin
          sStr1 := 'Undefined';
        end;
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[43] + #09 + sStr1);

      try
        sStr1 := ExifData1.OffsetSchema.AsString;
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[44] + #09 + sStr1);

      try
        sStr1 := ExifData1.RelatedSoundFile;
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[45] + #09 + sStr1);

      try
        if ExifData1.Rendering = erTagMissing then
        begin
          sStr1 := '';
        end
        else if ExifData1.Rendering = erNormal then
        begin
          sStr1 := 'Normal';
        end
        else if ExifData1.Rendering = erCustom then
        begin
          sStr1 := 'Custom';
        end
        else
        begin
          sStr1 := 'Undefined';
        end;
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[46] + #09 + sStr1);

      try
        if ExifData1.Saturation = euTagMissing then
        begin
          sStr1 := '';
        end
        else if ExifData1.Saturation = euNormal then
        begin
          sStr1 := 'Normal';
        end
        else if ExifData1.Saturation = euLow then
        begin
          sStr1 := 'Low';
        end
        else if ExifData1.Saturation = euHigh then
        begin
          sStr1 := 'High';
        end
        else
        begin
          sStr1 := 'Undefined';
        end;
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[47] + #09 + sStr1);

      try
        if ExifData1.SceneCaptureType = ecTagMissing then
        begin
          sStr1 := '';
        end
        else if ExifData1.SceneCaptureType = ecStandard then
        begin
          sStr1 := 'Standard';
        end
        else if ExifData1.SceneCaptureType = ecLandscape then
        begin
          sStr1 := 'Landscape';
        end
        else if ExifData1.SceneCaptureType = ecPortrait then
        begin
          sStr1 := 'Portrait';
        end
        else if ExifData1.SceneCaptureType = ecNightScene then
        begin
          sStr1 := 'Night Scene';
        end
        else
        begin
          sStr1 := 'Undefined';
        end;
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[48] + #09 + sStr1);

      try
        if ExifData1.SceneType = esUnknown then
        begin
          sStr1 := 'Unknown';
        end
        else if ExifData1.SceneType = esDirectlyPhotographed then
        begin
          sStr1 := 'Directly Photographed';
        end
        else
        begin
          sStr1 := 'Undefined';
        end;
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[49] + #09 + sStr1);

      try
        if ExifData1.SensingMethod = esTagMissing then
        begin
          sStr1 := '';
        end
        else if ExifData1.SensingMethod = esMonochrome then
        begin
          sStr1 := 'Monochrome';
        end
        else if ExifData1.SensingMethod = esOneChip then
        begin
          sStr1 := 'One Chip';
        end
        else if ExifData1.SensingMethod = esTwoChip then
        begin
          sStr1 := 'TwoC hip';
        end
        else if ExifData1.SensingMethod = esThreeChip then
        begin
          sStr1 := 'Three Chip';
        end
        else if ExifData1.SensingMethod = esColorSequential then
        begin
          sStr1 := 'Color Sequential';
        end
        else if ExifData1.SensingMethod = esTrilinear then
        begin
          sStr1 := 'Trilinear';
        end
        else if ExifData1.SensingMethod = esColorSequentialLinear then
        begin
          sStr1 := 'Color Sequential Linear';
        end
        else
        begin
          sStr1 := 'Undefined';
        end;
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[50] + #09 + sStr1);

      try
        if ExifData1.Sharpness = ehTagMissing then
        begin
          sStr1 := '';
        end
        else if ExifData1.Sharpness = ehNormal then
        begin
          sStr1 := 'Normal';
        end
        else if ExifData1.Sharpness = ehSoft then
        begin
          sStr1 := 'Soft';
        end
        else if ExifData1.Sharpness = ehHard then
        begin
          sStr1 := 'Hard';
        end
        else
        begin
          sStr1 := 'Undefined';
        end;
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[51] + #09 + sStr1);

      try
        sStr1 := FloatToStr(ExifData1.ShutterSpeedInMSecs);
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[52] + #09 + sStr1 + 'msec');

      try
        sStr1 := ExifData1.SpectralSensitivity;
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[53] + #09 + sStr1);

      try
        sStr1 := ExifData1.SubjectDistance.AsString;
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[54] + #09 + sStr1);

      try
        if ExifData1.SubjectDistanceRange = edTagMissing then
        begin
          sStr1 := '';
        end
        else if ExifData1.SubjectDistanceRange = edUnknown then
        begin
          sStr1 := 'Unknown';
        end
        else if ExifData1.SubjectDistanceRange = edMacro then
        begin
          sStr1 := 'Macro';
        end
        else if ExifData1.SubjectDistanceRange = edClose then
        begin
          sStr1 := 'Close';
        end
        else if ExifData1.SubjectDistanceRange = edDistant then
        begin
          sStr1 := 'Distant';
        end
        else
        begin
          sStr1 := 'Undefined';
        end;
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[55] + #09 + sStr1);

      try
        sStr1 := Format('%d x %d', [ExifData1.SubjectLocation.X,
                                    ExifData1.SubjectLocation.Y]);
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[56] + #09 + sStr1); //ExifData1.SubjectLocation

      try
        if ExifData1.WhiteBalanceMode = ewTagMissing then
        begin
          sStr1 := '';
        end
        else if ExifData1.WhiteBalanceMode = ewAuto then
        begin
          sStr1 := 'Auto';
        end
        else if ExifData1.WhiteBalanceMode = ewManual then
        begin
          sStr1 := 'Manual';
        end
        else
        begin
          sStr1 := 'Undefined';
        end;
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[57] + #09 + sStr1);

      try
        sStr1 := ExifData1.SubsecTime;
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[58] + #09 + sStr1);

      try
        sStr1 := ExifData1.SubsecTimeOriginal;
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[59] + #09 + sStr1);

      try
        sStr1 := ExifData1.SubsecTimeDigitized;
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[60] + #09 + sStr1);

      try
        sStr1 := ExifData1.InteropTypeName;
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[61] + #09 + sStr1);

      try
        sStr1 := ExifData1.InteropVersion.AsString;
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[62] + #09 + sStr1);

      try
        sStr1 := ExifData1.GPSVersion.AsString;
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[63] + #09 + sStr1);


      try
        sStr1 := DegMinSecToStr(ExifData1.GPSLatitude.AsString);
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[64] + #09 + sStr1);

      try
        sStr1 := DegMinSecToStr(ExifData1.GPSLongitude.AsString);
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[65] + #09 + sStr1);

      try
        if ExifData1.GPSAltitudeRef = alTagMissing then
        begin
          sStr1 := '';
        end
        else if ExifData1.GPSAltitudeRef = alAboveSeaLevel then
        begin
          sStr1 := 'Above Sea Level';
        end
        else if ExifData1.GPSAltitudeRef = alBelowSeaLevel then
        begin
          sStr1 := 'Below Sea Level';
        end
        else
        begin
          sStr1 := 'Undefined';
        end;
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[66] + #09 + sStr1);

      try
        sStr1 := ExifData1.GPSAltitude.AsString;
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[67] + #09 + sStr1);

      try
        sStr1 := ExifData1.GPSSatellites;
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[68] + #09 + sStr1);

      try
        if ExifData1.GPSStatus = stMissingOrInvalid then
        begin
          sStr1 := '';
        end
        else if ExifData1.GPSStatus = stMeasurementActive then
        begin
          sStr1 := 'Measurement active/in progress';
        end
        else if ExifData1.GPSStatus = stMeasurementVoid then
        begin
          sStr1 := 'Measurement void/in interop';
        end
        else
        begin
          sStr1 := 'Undefined';
        end;
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[69] + #09 + sStr1);

      try
        if ExifData1.GPSMeasureMode = mmUnknown then
        begin
          sStr1 := '';
        end
        else if ExifData1.GPSMeasureMode = mm2D then
        begin
          sStr1 := '2D';
        end
        else if ExifData1.GPSMeasureMode = mm3D then
        begin
          sStr1 := '3D';
        end
        else
        begin
          sStr1 := 'Undefined';
        end;
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[70] + #09 + sStr1);

      try
        sStr1 := ExifData1.GPSDOP.AsString;
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[71] + #09 + sStr1);

      try
        if ExifData1.GPSSpeedRef = srMissingOrInvalid then
        begin
          sStr1 := 'Kilometres Per Hour';
        end
        else if ExifData1.GPSSpeedRef = srKilometresPerHour then
        begin
          sStr1 := 'Kilometres Per Hour';
        end
        else if ExifData1.GPSSpeedRef = srMilesPerHour then
        begin
          sStr1 := 'Miles Per Hour';
        end
        else if ExifData1.GPSSpeedRef = srKnots then
        begin
          sStr1 := 'Knots';
        end
        else
        begin
          sStr1 := 'Undefined';
        end;
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[72] + #09 + sStr1);

      try
        sStr1 := ExifData1.GPSSpeed.AsString;
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[73] + #09 + sStr1);

      try
        if ExifData1.GPSTrackRef = drMissingOrInvalid then
        begin
          sStr1 := 'True North';
        end
        else if ExifData1.GPSTrackRef = drTrueNorth then
        begin
          sStr1 := 'True North';
        end
        else if ExifData1.GPSTrackRef = drMagneticNorth then
        begin
          sStr1 := 'Magnetic North';
        end
        else
        begin
          sStr1 := 'Undefined';
        end;
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[74] + #09 + sStr1);

      try
        sStr1 := ExifData1.GPSTrack.AsString;
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[75] + #09 + sStr1);

      try
        if ExifData1.GPSImgDirectionRef = drMissingOrInvalid then
        begin
          sStr1 := 'True North';
        end
        else if ExifData1.GPSImgDirectionRef = drTrueNorth then
        begin
          sStr1 := 'True North';
        end
        else if ExifData1.GPSImgDirectionRef = drMagneticNorth then
        begin
          sStr1 := 'Magnetic North';
        end
        else
        begin
          sStr1 := 'Undefined';
        end;
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[76] + #09 + sStr1);

      try
        sStr1 := ExifData1.GPSImgDirection.AsString;
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[77] + #09 + sStr1);

      try
        sStr1 := ExifData1.GPSMapDatum;
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[78] + #09 + sStr1);

      try
        sStr1 := ExifData1.GPSDestLatitude.AsString;
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[79] + #09 + sStr1);

      try
        sStr1 := ExifData1.GPSDestLongitude.AsString;
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[80] + #09 + sStr1);

      try
        if ExifData1.GPSDestBearingRef = drMissingOrInvalid then
        begin
          sStr1 := 'True North';
        end
        else if ExifData1.GPSDestBearingRef = drTrueNorth then
        begin
          sStr1 := 'True North';
        end
        else if ExifData1.GPSDestBearingRef = drMagneticNorth then
        begin
          sStr1 := 'Magnetic North';
        end
        else
        begin
          sStr1 := 'Undefined';
        end;
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[81] + #09 + sStr1);

      try
        sStr1 := ExifData1.GPSDestBearing.AsString;
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[82] + #09 + sStr1);

      try
        if ExifData1.GPSDestDistanceRef = dsMissingOrInvalid then
        begin
          sStr1 := 'Kilometres';
        end
        else if ExifData1.GPSDestDistanceRef = dsKilometres then
        begin
          sStr1 := 'Kilometres';
        end
        else if ExifData1.GPSDestDistanceRef = dsMiles then
        begin
          sStr1 := 'Miles';
        end
        else if ExifData1.GPSDestDistanceRef = dsKnots then
        begin
          sStr1 := 'Knots';
        end
        else
        begin
          sStr1 := 'Undefined';
        end;
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[83] + #09 + sStr1);

      try
        sStr1 := ExifData1.GPSDestDistance.AsString;
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[84] + #09 + sStr1);

      try
        if ExifData1.GPSDifferential = dfTagMissing then
        begin
          sStr1 := '';
        end
        else if ExifData1.GPSDifferential = dfWithoutCorrection then
        begin
          sStr1 := 'Without Correction';
        end
        else if ExifData1.GPSDifferential = dfCorrectionApplied then
        begin
          sStr1 := 'Correction Applied';
        end
        else
        begin
          sStr1 := 'Undefined';
        end;
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[85] + #09 + sStr1);

      try
        sStr1 := ExifData1.GPSDateTimeUTC.AsString;
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[86] + #09 + sStr1);

      try
        sStr1 := ExifData1.GPSDateStamp;
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[87] + #09 + sStr1);

      try
        sStr1 := ExifData1.GPSTimeStampHour.AsString;
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[88] + #09 + sStr1);

      try
        sStr1 := ExifData1.GPSTimeStampMinute.AsString;
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[89] + #09 + sStr1);

      try
        sStr1 := ExifData1.GPSTimeStampSecond.AsString;
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[90] + #09 + sStr1);

      try
        if ExifData1.ThumbnailOrientation = toUndefined then
        begin
          sStr1 := '';
        end
        else if ExifData1.ThumbnailOrientation = toTopLeft then
        begin
          sStr1 := 'Normal';
        end
        else if ExifData1.ThumbnailOrientation = toTopRight then
        begin
          sStr1 := 'Mirror horizontal';
        end
        else if ExifData1.ThumbnailOrientation = toBottomRight then
        begin
          sStr1 := 'Rotate 180';
        end
        else if ExifData1.ThumbnailOrientation = toBottomLeft then
        begin
          sStr1 := 'Mirror vertical';
        end
        else if ExifData1.ThumbnailOrientation = toLeftTop then
        begin
          sStr1 := 'Mirror horizontal and rotate 270';
        end
        else if ExifData1.ThumbnailOrientation = toRightTop then
        begin
          sStr1 := 'Rotate 90';
        end
        else if ExifData1.ThumbnailOrientation = toRightBottom then
        begin
          sStr1 := 'Mirror hotizontal and rotate 90';
        end
        else if ExifData1.ThumbnailOrientation = toLeftBottom then
        begin
          sStr1 := 'Rotate 270';
        end
        else
        begin
          sStr1 := 'Undefined';
        end;
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[91] + #09 + sStr1);

      try
        sStr1 := Format('%g x %g %s', [ExifData1.ThumbnailResolution.X.Quotient,
                                       ExifData1.ThumbnailResolution.Y.Quotient,
                                       ResolutionUnitsToStr(ExifData1.ThumbnailResolution.Units)]);
      except
        sStr1 := '---';
      end;
      StrList1.Add(StrListCcr.Strings[92] + #09 + sStr1); //ExifData1.ThumbnailResolution);
    finally
      //j
      ExifData1.Free;
    end;

    //ۑ
    StrList1.SaveToFile(ExtractFilePath(ParamStr(0)) + CCR_TXT);
  end;

  //\
  ListView1.Items.BeginUpdate;
  ListView1.Items.Clear;
  for iRow1 := 0 to StrList1.Count-1 do
  begin
    //WJ
    CsvList93.Clear;
    StringToCsvList(StrList1.Strings[iRow1], CsvList93);
    //1sݒ
    nItem := ListView1.Items.Add;
    nItem.Caption := CsvList93[0];
    ListView1.Items.Item[iRow1].SubItems.add(CsvList93[1]);
    ListView1.Items.Item[iRow1].SubItems.add(CsvList93[2]);
    ListView1.Items.Item[iRow1].SubItems.add(CsvList93[3]);
  end;
  ListView1.Items.EndUpdate;

  //j
  StrList1.Free;
  StrList2.Free;
  CsvList91.Free;
  CsvList92.Free;
  CsvList93.Free;

end;


procedure TFormExifCcrExif.GetFunction(StrList: TStringList; var FunctionCode: Integer; var Key: Word; Shift: TShiftState);
var
  iRow1: Integer;
  iStatus: Integer;
begin
  //VtgԂ擾
  iStatus := 0;
  if (shift = [ssShift]) then
  begin
    iStatus := iStatus + 1;
  end;
  if (shift = [ssCtrl]) then
  begin
    iStatus := iStatus + 2;
  end;
  if (shift = [ssAlt]) then
  begin
    iStatus := iStatus + 4;
  end;

  //L[f[^XL
  FunctionCode := 0;
  for iRow1 := 0 to StrList.Count-1 do
  begin
    //L[f[^̊eڂ擾
    CsvList2.clear;
    StringToCsvList(StrList.Strings[iRow1], CsvList2);
    if iStatus = StrToInt(CsvList2[0]) then
    begin
      if key = StrToInt(CsvList2[2]) then
      begin
        FunctionCode := StrToInt(CsvList2[4]);
        Exit;
      end;
    end;
  end;
end;

function  TFormExifCcrExif.CheckJfifExifFile(FileName: String): Boolean;
var
  Stream1: TBytesStream;
begin
  //
  Result := FALSE;
  //m
  Stream1 := TBytesStream.Create;
  //ǂݍ
  try
    //t@C̓eXg[ɓǂݏo
    Stream1.LoadFromFile(FileName);
    //
    if Stream1.Size >= 10 then
    begin
      if ((Stream1.Bytes[ 0] = $FF) and (Stream1.Bytes[ 1] = $D8) and
          (Stream1.Bytes[ 2] = $FF) and (Stream1.Bytes[ 3] = $E1) and
          (Stream1.Bytes[ 6] = $45) and (Stream1.Bytes[ 7] = $78) and
          (Stream1.Bytes[ 8] = $69) and (Stream1.Bytes[ 9] = $66)) or
         ((Stream1.Bytes[ 0] = $FF) and (Stream1.Bytes[ 1] = $D8) and
          (Stream1.Bytes[ 2] = $FF) and (Stream1.Bytes[ 3] = $E0) and
          (Stream1.Bytes[ 6] = $4A) and (Stream1.Bytes[ 7] = $46) and
          (Stream1.Bytes[ 8] = $49) and (Stream1.Bytes[ 9] = $46)) then
         //
         Result := TRUE;
    end;
  finally
    //j
    FreeAndNil(Stream1);
  end;
end;

end.

