unit ExifExifInfo;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, ExifInfo, Vcl.Menus, Vcl.StdCtrls,
  Vcl.ComCtrls, MyListView, Vcl.ExtCtrls,
  IniFiles, MyUtility;

const
  FORM_WIDTH_SET       = 510;
  FORM_HEIGHT_SET      = 420;
  FORM_MAX             = 'MAX';
  FORM_MIN             = 'MIN';
  FORM_NORMAL          = 'NORMAL';
  LISTBOX3_WIDTH       = 385;

  EXIF_DATA_0          = '  ';
  EXIF_DATA_1          = 'ID';
  EXIF_DATA_2          = '';
  EXIF_DATA_3          = 'f[^';
  EXIF_DATA_4          = '  ';

  LIST_COLUM_WIDH_0    =  35;
  LIST_COLUM_WIDH_1    =  70;
  LIST_COLUM_WIDH_2    = 250;
  LIST_COLUM_WIDH_3    = 300;
  LIST_COLUM_WIDH_4    =  30;

type
  TFormExifExifInfo = class(TForm)
    Panel2: TPanel;
    ListView1: TMyListView;
    Memo1: TMemo;
    Panel1: TPanel;
    Label1: TLabel;
    MainMenu1: TMainMenu;
    MenuFile: TMenuItem;
    MenuQuit: TMenuItem;
    MenuSetting: TMenuItem;
    MenuWindowPosition: TMenuItem;
    ExifInfo1: TExifInfo;

    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormResize(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);

    procedure WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo); message WM_GETMINMAXINFO;

    procedure MenuQuitClick(Sender: TObject);
    procedure MenuWindowPositionClick(Sender: TObject);

    procedure GetFunction(StrList: TStringList; var FunctionCode: Integer; var Key: Word; Shift: TShiftState);

    procedure GetValue(FileName: String; Sender: TObject);
    function  GetExifDataInfo(id: String): String;
    function  CheckJpgFile(FileName: String): Boolean;

    procedure ListView1ColumnClick(Sender: TObject; Column: TListColumn);

  private
    { Private 錾 }
    FormPosLeft: Integer;
    FormPosTop: Integer;
    FormPosWidth: Integer;
    FormPosHeight: Integer;
    FormPosRight: Integer;
    FormPosButtom: Integer;

    MonitorTop: Integer;
    MonitorLeft: Integer;
    MonitorRight: Integer;
    MonitorButtom: Integer;
    MonitorWidth: Integer;
    MonitorHeight: Integer;

    StrFormState: String;

    StrListExif: TStringList;
    StrListPropaty: TStringList;
    StrListCcr: TStringList;
    CsvList2: TStringList;

    iTogle: Integer;

  public
    { Public 錾 }

  end;

var
  FormExifExifInfo: TFormExifExifInfo;

implementation

uses
  Main;

{$R *.dfm}

function ItemSort1(Item1,Item2: TListItem; SortColumn: Integer): Integer; stdcall;
begin
  //\[gݒ
  case SortColumn of
    0:   Result := -lstrcmp(PChar(Item1.Caption),                PChar(Item2.Caption));
    else Result := -lstrcmp(PChar(Item1.SubItems[SortColumn-1]), PChar(Item2.SubItems[SortColumn-1]));
   end;
end;

function ItemSort2(Item1,Item2: TListItem; SortColumn: Integer): Integer; stdcall;
begin
  //\[gݒ
  case SortColumn of
    0:   Result :=  lstrcmp(PChar(Item1.Caption),                PChar(Item2.Caption));
    else Result :=  lstrcmp(PChar(Item1.SubItems[SortColumn-1]), PChar(Item2.SubItems[SortColumn-1]));
   end;
end;

procedure TFormExifExifInfo.FormClose(Sender: TObject; var Action: TCloseAction);
var
  IniFile: TIniFile;
begin
  //ۑ
  if FormMain.bFormPositionSave = TRUE then
  begin
    MenuWindowPositionClick(Sender);
  end;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));

  //ݒ
  IniFile.WriteInteger('ExifInfoListViewWidth',  '0',  ListView1.Columns[0].Width);
  IniFile.WriteInteger('ExifInfoListViewWidth',  '1',  ListView1.Columns[1].Width);
  IniFile.WriteInteger('ExifInfoListViewWidth',  '2',  ListView1.Columns[2].Width);
  IniFile.WriteInteger('ExifInfoListViewWidth',  '3',  ListView1.Columns[3].Width);
  IniFile.WriteInteger('ExifInfoListViewWidth',  '4',  ListView1.Columns[4].Width);

  //j
  IniFile.Free;

  //IMEIt
  SetImeMode(FormExifExifInfo.Handle, imClose);

  //tH[JX߂
  FormMain.SetFocus;
end;

procedure TFormExifExifInfo.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
;
end;

procedure TFormExifExifInfo.FormCreate(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //m
  StrListExif := TStringList.Create;
  StrListPropaty := TStringList.Create;
  StrListCcr := TStringList.Create;
  CsvList2 := TStringList.Create;

  //
  Label1.Caption := '';

  //
  Memo1.Visible := FALSE;
  Memo1.Align := alClient;

  //
  ListView1.Columns.Add.Caption := EXIF_DATA_0;
  ListView1.Columns.Add.Caption := EXIF_DATA_1;
  ListView1.Columns.Add.Caption := EXIF_DATA_2;
  ListView1.Columns.Add.Caption := EXIF_DATA_3;
  ListView1.Columns.Add.Caption := EXIF_DATA_4;
  ListView1.ViewStyle := vsReport;
  ListView1.RowSelect := TRUE;
  ListView1.MultiSelect := FALSE;
  ListView1.Align := alClient;
  ListView1.Visible := TRUE;
  ListView1.ReadOnly := TRUE;

//  FALSE:tH[JXړĂc
//  D7  FALSE
//  XE2 TRUE
  ListView1.HideSelection := TRUE;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));

  //tH[ʒu
  FormPosLeft   := IniFile.ReadInteger('FormExifExifInfo', 'Left',   0);
  FormPosTop    := IniFile.ReadInteger('FormExifExifInfo', 'Top',    0);
  FormPosWidth  := IniFile.ReadInteger('FormExifExifInfo', 'Width',  FORM_WIDTH_SET);
  FormPosHeight := IniFile.ReadInteger('FormExifExifInfo', 'Height', FORM_HEIGHT_SET);
  StrFormState  := IniFile.ReadString ('FormExifExifInfo', 'State',  FORM_NORMAL);
  FormPosRight  := FormPosLeft + FormPosWidth;
  FormPosButtom := FormPosTop  + FormPosHeight;

  //ݒ
  ListView1.Columns[ 0].Width := IniFile.ReadInteger('ExifInfoListViewWidth',  '0', LIST_COLUM_WIDH_0);
  ListView1.Columns[ 1].Width := IniFile.ReadInteger('ExifInfoListViewWidth',  '1', LIST_COLUM_WIDH_1);
  ListView1.Columns[ 2].Width := IniFile.ReadInteger('ExifInfoListViewWidth',  '2', LIST_COLUM_WIDH_2);
  ListView1.Columns[ 3].Width := IniFile.ReadInteger('ExifInfoListViewWidth',  '3', LIST_COLUM_WIDH_3);
  ListView1.Columns[ 4].Width := IniFile.ReadInteger('ExifInfoListViewWidth',  '4', LIST_COLUM_WIDH_4);

  //j
  IniFile.Free;

end;

procedure TFormExifExifInfo.FormDestroy(Sender: TObject);
begin
  //j
  StrListExif.Free;
  StrListPropaty.Free;
  StrListCcr.Free;
  CsvList2.Free;
end;

procedure TFormExifExifInfo.FormShow(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //FormłȂ̂ŁACreatełȂShowōs
  //FormKeyDowñCxgݒ肷
  FormExifExifInfo.KeyPreview := TRUE;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));

  //tH[ʒu
  FormPosLeft   := IniFile.ReadInteger('FormExifExifInfo', 'Left',   0);
  FormPosTop    := IniFile.ReadInteger('FormExifExifInfo', 'Top',    0);
  FormPosWidth  := IniFile.ReadInteger('FormExifExifInfo', 'Width',  FORM_WIDTH_SET);
  FormPosHeight := IniFile.ReadInteger('FormExifExifInfo', 'Height', FORM_HEIGHT_SET);
  StrFormState  := IniFile.ReadString ('FormExifExifInfo', 'State',  FORM_NORMAL);
  FormPosRight  := FormPosLeft + FormPosWidth;
  FormPosButtom := FormPosTop  + FormPosHeight;


  //ݒ
  ListView1.Columns[ 0].Width := IniFile.ReadInteger('ExifInfoListViewWidth',  '0', LIST_COLUM_WIDH_0);
  ListView1.Columns[ 1].Width := IniFile.ReadInteger('ExifInfoListViewWidth',  '1', LIST_COLUM_WIDH_1);
  ListView1.Columns[ 2].Width := IniFile.ReadInteger('ExifInfoListViewWidth',  '2', LIST_COLUM_WIDH_2);
  ListView1.Columns[ 3].Width := IniFile.ReadInteger('ExifInfoListViewWidth',  '3', LIST_COLUM_WIDH_3);
  ListView1.Columns[ 4].Width := IniFile.ReadInteger('ExifInfoListViewWidth',  '4', LIST_COLUM_WIDH_4);

  //j
  IniFile.Free;

  //GetSystemMetricst֐gpāCzʑŜ̃TCY擾
  MonitorTop    := GetSystemMetrics(SM_YVIRTUALSCREEN);
  MonitorLeft   := GetSystemMetrics(SM_XVIRTUALSCREEN);
  MonitorWidth  := GetSystemMetrics(SM_CXVIRTUALSCREEN);
  MonitorHeight := GetSystemMetrics(SM_CYVIRTUALSCREEN);
  MonitorRight  := MonitorLeft + MonitorWidth;
  MonitorButtom := MonitorTop  + MonitorHeight;

  //\ł ȌԂŕ\
  if ( (MonitorTop  <= FormPosTop  + FORM_TOP_SHIFT ) and (FormPosTop    <= MonitorButtom) ) and
     ( (MonitorTop  <= FormPosButtom                ) and (FormPosButtom <= MonitorButtom) ) and
     ( (MonitorLeft <= FormPosLeft + FORM_LEFT_SHIFT) and (FormPosLeft   <= MonitorRight ) ) and
     ( (MonitorLeft <= FormPosRight                 ) and (FormPosRight  <= MonitorRight ) ) then
  begin
    FormExifExifInfo.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end
  //ʓɕ\łȂ ftHgŕ\
  else
  begin
    FormExifExifInfo.SetBounds(0, 0 ,FORM_WIDTH_SET, FORM_HEIGHT_SET);
  end;

  //ő
  if StrFormState = FORM_MAX then
  begin
    FormExifExifInfo.WindowState := wsMaximized;
  end
  //ŏ
  else if StrFormState = FORM_MIN then
  begin
    FormExifExifInfo.WindowState := wsMinimized;
  end
  //W
  else
  begin
    //
  end;

  //IMEIt
  SetImeMode(FormExifExifInfo.Handle, imClose);

end;

procedure TFormExifExifInfo.FormResize(Sender: TObject);
begin
;
end;

procedure TFormExifExifInfo.WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
begin
  //ŏTCY
  with msg.MinMaxInfo^.ptMinTrackSize do
  begin
    x := FORM_WIDTH_SET;
    y := FORM_HEIGHT_SET;
  end;
  //őTCY
  with msg.MinMaxInfo^.ptMaxTrackSize do
  begin
    //
  end;
  //ő剻TCY
  with msg.MinMaxInfo^.ptMaxSize do
  begin
    //
  end;
end;

procedure TFormExifExifInfo.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
var
  iFunc1: Integer;
begin
  //@\擾
  GetFunction(FormMain.StrListKeyMain, iFunc1, Key, Shift);
  case iFunc1 of
    601 :  //I
      begin
        if FormMain.MenuExitEscape.Checked = TRUE then
        begin
          MenuQuitClick(Sender);
        end;
        key := 0;
      end;
    602 :  //I
      begin
        if FormMain.MenuExitKeyQ.Checked = TRUE then
        begin
          MenuQuitClick(Sender);
        end;
        key := 0;
      end;
  end;
end;

procedure TFormExifExifInfo.FormKeyPress(Sender: TObject; var Key: Char);
begin
  //
  key := #0;
end;

procedure TFormExifExifInfo.ListView1ColumnClick(Sender: TObject; Column: TListColumn);
begin
  //\[g̔]
  iTogle := (iTogle+1) mod 2;
  if iTogle = 0 then
  begin
    ListView1.CustomSort(@ItemSort2, Column.Index);
  end
  else
  begin
    ListView1.CustomSort(@ItemSort1, Column.Index);
  end;
end;

procedure TFormExifExifInfo.MenuQuitClick(Sender: TObject);
begin
  //I
  Close;
end;

procedure TFormExifExifInfo.MenuWindowPositionClick(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));

  //ʏ
  if WindowState = wsMaximized then
  begin
    IniFile.WriteString ('FormExifExifInfo', 'State', FORM_MAX);
  end
  else if WindowState = wsMinimized then
  begin
    IniFile.WriteString ('FormExifExifInfo', 'State', FORM_MIN);
  end
  else
  begin
    IniFile.WriteString ('FormExifExifInfo', 'State', FORM_NORMAL);
    //ʃTCY
    IniFile.WriteInteger('FormExifExifInfo', 'Left',   FormExifExifInfo.Left);
    IniFile.WriteInteger('FormExifExifInfo', 'Top',    FormExifExifInfo.Top);
    IniFile.WriteInteger('FormExifExifInfo', 'Width',  FormExifExifInfo.Width);
    IniFile.WriteInteger('FormExifExifInfo', 'Height', FormExifExifInfo.Height);
  end;

  //j
  IniFile.Free;
end;


function  TFormExifExifInfo.GetExifDataInfo(id: String): String;
begin
  if      id = '$9000' then
  begin
    try
      Result := ExifInfo1.ExifVersion;
    except
      Result := '---';
    end;
  end
  else if id = '$0000' then
  begin
    try
      Result := IntToStr(ExifInfo1.GPSVersionID[0]) + '.' +
                IntToStr(ExifInfo1.GPSVersionID[1]) + '.' +
                IntToStr(ExifInfo1.GPSVersionID[2]) + '.' +
                IntToStr(ExifInfo1.GPSVersionID[3]);
    except
      Result := '---';
    end;
  end
  else if id = '$A000' then
  begin
    try
      Result := ExifInfo1.FlashPixVersion;
    except
      Result := '---';
    end;
  end
  else if id = '$9286' then
  begin
    try
      Result := ExifInfo1.UserComment;
    except
      Result := '---';
    end;
  end
  else if id = '$010F' then
  begin
    try
      Result := ExifInfo1.Make;
    except
      Result := '---';
    end;
  end
  else if id = '$0110' then
  begin
    try
      Result := ExifInfo1.Model;
    except
      Result := '---';
    end;
  end
  else if id = '$0131' then
  begin
    try
      Result := ExifInfo1.Software;
    except
      Result := '---';
    end;
  end
  else if id = '$8298' then
  begin
    try
      Result := ExifInfo1.Copyright;
    except
      Result := '---';
    end;
  end
  else if id = '$013B' then
  begin
    try
      Result := ExifInfo1.Artist;
    except
      Result := '---';
    end;
  end
  else if id = '$9003' then
  begin
    try
      Result := ExifInfo1.DateTimeOriginalText;
    except
      Result := '---';
    end;
  end
  else if id = '$0132' then
  begin
    try
      Result := ExifInfo1.DateTimeText;
    except
      Result := '---';
    end;
  end
  else if id = '$0101' then
  begin
    try
      Result := FormatFloat('###,###', ExifInfo1.ImageLength);
    except
      Result := '---';
    end;
  end
  else if id = '$0100' then
  begin
    try
      Result := FormatFloat('###,###', ExifInfo1.ImageWidth);
    except
      Result := '---';
    end;
  end
  else if id = '$9207' then
  begin
    try
      Result := ExifInfo1.MeteringModeText;
    except
      Result := '---';
    end;
  end
  else if id = '$9208' then
  begin
    try
      Result := ExifInfo1.LightSourceText;
    except
      Result := '---';
    end;
  end
  else if id = '$9209' then
  begin
    try
      if ExifInfo1.Flash = TRUE then
      begin
        Result := 'gp';
      end
      else
      begin
        Result := 'gp'
      end;
    except
      Result := '---';
    end;
  end
  else if id = '$A217' then
  begin
    try
      Result := ExifInfo1.SensingMethodText;
    except
      Result := '---';
    end;
  end
  else if id = '$9206' then
  begin
    try
      Result := FormatFloat('0.000', ExifInfo1.SubjectDistance.Value);
//      Result := FormatFloat('###,###', ExifInfo1.SubjectDistance.Value);
    except
      Result := '---';
    end;
  end
  else if id = '$0012' then
  begin
    try
      Result := ExifInfo1.GPSMapDatum;
    except
      Result := '---';
    end;
  end
  else if id = '$000A' then
  begin
    try
      Result := ExifInfo1.GPSMeasureMode;
    except
      Result := '---';
    end;
  end
  else if id = '$0009' then
  begin
    try
      Result := ExifInfo1.GPSStatus;
    except
      Result := '---';
    end;
  end
  else if id = '$0006' then
  begin
    try
      Result := FormatFloat('0.000', ExifInfo1.GPSAltitude.Value);
//      Result := FormatFloat('###,###.###', ExifInfo1.GPSAltitude.Value);
    except
      Result := '---';
    end;
  end
  else if id = '$0001' then
  begin
    try
      Result := ExifInfo1.GPSLatitudeRef                           + ' ' +
                FormatFloat('##0', ExifInfo1.GPSLatitude[0].Value) + 'x' +
                FormatFloat('##0', ExifInfo1.GPSLatitude[1].Value) + '' +
                FormatFloat('##0', ExifInfo1.GPSLatitude[2].Value) + 'b';
    except
      Result := '---';
    end;
  end
  else if id = '$0003' then
  begin
    try
      Result := ExifInfo1.GPSLongitudeRef                          + ' ' +
                FormatFloat('##0', ExifInfo1.GPSLongitude[0].Value) + 'x' +
                FormatFloat('##0', ExifInfo1.GPSLongitude[1].Value) + '' +
                FormatFloat('##0', ExifInfo1.GPSLongitude[2].Value) + 'b';
    except
      Result := '---';
    end;
  end

  else if id = '$0112' then
  begin
    try
      if      ExifInfo1.Orientation = eoReserved then
      begin
        Result := 'eoReserved';
      end
      else if ExifInfo1.Orientation = eoTopLeft then
      begin
        Result := 'eoTopLeft';
      end
      else if ExifInfo1.Orientation = eoTopRight then
      begin
        Result := 'eoTopRight';
      end
      else if ExifInfo1.Orientation = eoBottomRight then
      begin
        Result := 'eoBottomRight';
      end
      else if ExifInfo1.Orientation = eoBottomLeft then
      begin
        Result := 'eoBottomLeft';
      end
      else if ExifInfo1.Orientation = eoLeftTop then
      begin
        Result := 'eoLeftTop';
      end
      else if ExifInfo1.Orientation = eoRightTop then
      begin
        Result := 'eoRightTop';
      end
      else if ExifInfo1.Orientation = eoRightBottom then
      begin
        Result := 'eoRightBottom';
      end
      else if ExifInfo1.Orientation = eoLeftBottom then
      begin
        Result := 'eoLeftBottom';
      end
      else
      begin
        Result := 'UnKnown';
      end;
    except
      Result := '---';
    end;
  end
  else if id = '$9004' then
  begin
    try
      Result := ExifInfo1.DateTimeDigitizedText;
    except
      Result := '---';
    end;
  end
  else if id = '$0102' then
  begin
    try
      Result := IntToStr(ExifInfo1.BitsPerSample[0] + ExifInfo1.BitsPerSample[1] + ExifInfo1.BitsPerSample[2]);
    except
      Result := '---';
    end;
  end

  else
  begin
    Result := '===';
  end;
end;

procedure TFormExifExifInfo.GetValue(FileName: String; Sender: TObject);

var
  sStr1: String;
  nItem: TListItem;
  sValue: String;
  iRow1: Integer;
  StrList1: TStringList;
  StrList2: TStringList;
  CsvList91: TStringList;
  CsvList92: TStringList;
  CsvList93: TStringList;
begin
  //
  Label1.Caption := ExtractFileName(FileName);

  //\Ȃ牽Ȃ
  if FormExifExifInfo.Visible = FALSE then
  begin
    Exit;
  end;

  //NA
  ListView1.Items.BeginUpdate;
  ListView1.Items.Clear;
  ListView1.Items.EndUpdate;

  //m
  StrList1 := TStringList.Create;
  StrList2 := TStringList.Create;
  CsvList91 := TStringList.Create;
  CsvList92 := TStringList.Create;
  CsvList93 := TStringList.Create;

  //JFIFłȂ
  if CheckJpgFile(FileName) = FALSE then
  begin
    //
    ShowMessage('Information : JPG(JFIF) ̃@C ExifInfo ł͓ǂݍ߂܂B');
    //ۑ
    StrList1.SaveToFile   (ExtractFilePath(ParamStr(0)) + EXIF_TXT);
  end
  //JFIF
  else
  begin
    //ݒ
    StrListExif.Clear;
    StrListExif.Add(EXIF_DATA_0 + #09 + '$9000' + #09 + 'Exif Version');
    StrListExif.Add(EXIF_DATA_0 + #09 + '$0000' + #09 + 'GPS Version');
    StrListExif.Add(EXIF_DATA_0 + #09 + '$A000' + #09 + 'FlashPix Version');
    StrListExif.Add(EXIF_DATA_0 + #09 + '$9286' + #09 + 'Rg');
    StrListExif.Add(EXIF_DATA_0 + #09 + '$010F' + #09 + '[J[');
    StrListExif.Add(EXIF_DATA_0 + #09 + '$0110' + #09 + '@햼');
    StrListExif.Add(EXIF_DATA_0 + #09 + '$0131' + #09 + '\tgEGA');
    StrListExif.Add(EXIF_DATA_0 + #09 + '$8298' + #09 + '쌠');
    StrListExif.Add(EXIF_DATA_0 + #09 + '$013B' + #09 + 'Be(ҏW)');
    StrListExif.Add(EXIF_DATA_0 + #09 + '$9003' + #09 + 'Be');
    StrListExif.Add(EXIF_DATA_0 + #09 + '$0132' + #09 + 'ŏIҏW');
    StrListExif.Add(EXIF_DATA_0 + #09 + '$9004' + #09 + 'fW^f[^̍쐬');
    StrListExif.Add(EXIF_DATA_0 + #09 + '$0101' + #09 + '摜 Pixel');
    StrListExif.Add(EXIF_DATA_0 + #09 + '$0100' + #09 + '摜 Pixel');
    StrListExif.Add(EXIF_DATA_0 + #09 + '$0112' + #09 + '摜');
    StrListExif.Add(EXIF_DATA_0 + #09 + '$0102' + #09 + 'rbg[x');
    StrListExif.Add(EXIF_DATA_0 + #09 + '$9207' + #09 + '[h');
    StrListExif.Add(EXIF_DATA_0 + #09 + '$9208' + #09 + '');
    StrListExif.Add(EXIF_DATA_0 + #09 + '$9209' + #09 + 'Xg{');
    StrListExif.Add(EXIF_DATA_0 + #09 + '$A217' + #09 + 'ZT');
    StrListExif.Add(EXIF_DATA_0 + #09 + '$9206' + #09 + 'ʑ̋(m)');
    StrListExif.Add(EXIF_DATA_0 + #09 + '$0012' + #09 + 'GPS nn');
    StrListExif.Add(EXIF_DATA_0 + #09 + '$000A' + #09 + 'GPS ʎ');
    StrListExif.Add(EXIF_DATA_0 + #09 + '$0009' + #09 + 'GPS ʒ');
    StrListExif.Add(EXIF_DATA_0 + #09 + '$0006' + #09 + 'GPS x(m)');
    StrListExif.Add(EXIF_DATA_0 + #09 + '$0001' + #09 + 'GPS ܓx');
    StrListExif.Add(EXIF_DATA_0 + #09 + '$0003' + #09 + 'GPS ox');

    //ݒ
    ExifInfo1.ImageFileName := FileName;
    //擾
    for iRow1 := 0 to StrListExif.Count-1 do
    begin
      //WJ
      CsvList92.Clear;
      StringToCsvList(StrListExif.Strings[iRow1], CsvList92);
      //vpeB
      if Copy(CsvList92[1], 1, 1) = '$' then
      begin
        //摜
        if CsvList92[1] = '$0112' then
        begin
          // 摜
          //TExifOrientation = (eoReserved, eoTopLeft, eoTopRight, eoBottomRight,
          //          eoBottomLeft, eoLeftTop, eoRightTop, eoRightBottom,
          //          eoLeftBottom);
          sValue := GetExifDataInfo(CsvList92[1]);
          if sValue = 'eoReserved' then
          begin
            sStr1 := ' [Reserved]';
          end
          else if sValue = 'eoTopLeft' then
          begin
            sStr1 := 'W [TopLeft]';
          end
          else if sValue = 'eoTopRight' then
          begin
            sStr1 := '~[  [TopRight]';
          end
          else if sValue = 'eoBottomRight' then
          begin
            sStr1 := ']180 [BottomRight]';
          end
          else if sValue = 'eoBottomLeft' then
          begin
            sStr1 := '~[  [BottomLeft]';
          end
          else if sValue = 'eoLeftTop' then
          begin
            sStr1 := '~[  ]270 [LeftTop]';
          end
          else if sValue = 'eoRightTop' then
          begin
            sStr1 := ']90 [RightTop]';
          end
          else if sValue = 'eoRightBottom' then
          begin
            sStr1 := '~[  ]90 [RightBottom]';
          end
          else if sValue = 'eoLeftBottom' then
          begin
            sStr1 := ']270 [LeftBottom]';
          end
          else
          begin
            sStr1 := 's [others]';
          end;
          StrList1.Add(StrListExif.Strings[iRow1] + #09 + sStr1);
        end
        else
        begin
          sValue := GetExifDataInfo(CsvList92[1]);
          StrList1.Add(StrListExif.Strings[iRow1] + #09 + sValue);
        end
      end;
    end;
    //ۑ
    StrList1.SaveToFile   (ExtractFilePath(ParamStr(0)) + EXIF_TXT);
  end;

  //\
  ListView1.Items.BeginUpdate;
  ListView1.Items.Clear;
  for iRow1 := 0 to StrList1.Count-1 do
  begin
    //WJ
    CsvList93.Clear;
    StringToCsvList(StrList1.Strings[iRow1], CsvList93);
    //1sݒ
    nItem := ListView1.Items.Add;
    nItem.Caption := CsvList93[0];
    ListView1.Items.Item[iRow1].SubItems.add(CsvList93[1]);
    ListView1.Items.Item[iRow1].SubItems.add(CsvList93[2]);
    ListView1.Items.Item[iRow1].SubItems.add(CsvList93[3]);
  end;
  ListView1.Items.EndUpdate;
  //j
  StrList1.Free;
  StrList2.Free;
  CsvList91.Free;
  CsvList92.Free;
  CsvList93.Free;

end;


procedure TFormExifExifInfo.GetFunction(StrList: TStringList; var FunctionCode: Integer; var Key: Word; Shift: TShiftState);
var
  iRow1: Integer;
  iStatus: Integer;
begin
  //VtgԂ擾
  iStatus := 0;
  if (shift = [ssShift]) then
  begin
    iStatus := iStatus + 1;
  end;
  if (shift = [ssCtrl]) then
  begin
    iStatus := iStatus + 2;
  end;
  if (shift = [ssAlt]) then
  begin
    iStatus := iStatus + 4;
  end;

  //L[f[^XL
  FunctionCode := 0;
  for iRow1 := 0 to StrList.Count-1 do
  begin
    //L[f[^̊eڂ擾
    CsvList2.clear;
    StringToCsvList(StrList.Strings[iRow1], CsvList2);
    if iStatus = StrToInt(CsvList2[0]) then
    begin
      if key = StrToInt(CsvList2[2]) then
      begin
        FunctionCode := StrToInt(CsvList2[4]);
        Exit;
      end;
    end;
  end;
end;

function  TFormExifExifInfo.CheckJpgFile(FileName: String): Boolean;
var
  Stream1: TBytesStream;
begin
  //
  Result := FALSE;
  //m
  Stream1 := TBytesStream.Create;
  //ǂݍ
  try
    //t@C̓eXg[ɓǂݏo
    Stream1.LoadFromFile(FileName);
    //
    if Stream1.Size >= 10 then
    begin
      if (Stream1.Bytes[ 0] = $FF) and (Stream1.Bytes[ 1] = $D8) and
         (Stream1.Bytes[ 2] = $FF) and (Stream1.Bytes[ 3] = $E1) and
         (Stream1.Bytes[ 6] = $45) and (Stream1.Bytes[ 7] = $78) and
         (Stream1.Bytes[ 8] = $69) and (Stream1.Bytes[ 9] = $66) then
         //
         Result := TRUE;
    end;
  finally
    //j
    FreeAndNil(Stream1);
  end;
end;

end.
