unit ExifShell;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.OleServer, Shell32_TLB, Vcl.Menus,
  Vcl.StdCtrls, Vcl.ComCtrls, MyListView, Vcl.ExtCtrls,
  IniFiles, MyUtility;

const
  FORM_WIDTH_SET       = 510;
  FORM_HEIGHT_SET      = 420;
  FORM_MAX             = 'MAX';
  FORM_MIN             = 'MIN';
  FORM_NORMAL          = 'NORMAL';
  LISTBOX3_WIDTH       = 385;

  EXIF_DATA_0          = '  ';
  EXIF_DATA_1          = 'ID';
  EXIF_DATA_2          = '';
  EXIF_DATA_3          = 'f[^';
  EXIF_DATA_4          = '  ';

  LIST_COLUM_WIDH_0    =  35;
  LIST_COLUM_WIDH_1    =  70;
  LIST_COLUM_WIDH_2    = 250;
  LIST_COLUM_WIDH_3    = 300;
  LIST_COLUM_WIDH_4    =  30;

type
  TFormExifShell = class(TForm)
    Panel2: TPanel;
    ListView1: TMyListView;
    Memo1: TMemo;
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    MainMenu1: TMainMenu;
    MenuFile: TMenuItem;
    MenuQuit: TMenuItem;
    MenuSetting: TMenuItem;
    MenuWindowPosition: TMenuItem;
    Shell1: TShell;

    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormResize(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);

    procedure WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo); message WM_GETMINMAXINFO;

    procedure MenuQuitClick(Sender: TObject);
    procedure MenuWindowPositionClick(Sender: TObject);

    procedure GetFunction(StrList: TStringList; var FunctionCode: Integer; var Key: Word; Shift: TShiftState);

    procedure GetValue(FileName: String; Sender: TObject);

    procedure ListView1ColumnClick(Sender: TObject; Column: TListColumn);

  private
    { Private 錾 }
    FormPosLeft: Integer;
    FormPosTop: Integer;
    FormPosWidth: Integer;
    FormPosHeight: Integer;
    FormPosRight: Integer;
    FormPosButtom: Integer;

    MonitorTop: Integer;
    MonitorLeft: Integer;
    MonitorRight: Integer;
    MonitorButtom: Integer;
    MonitorWidth: Integer;
    MonitorHeight: Integer;

    StrFormState: String;

    StrListExif: TStringList;
    StrListPropaty: TStringList;
    StrListCcr: TStringList;
    CsvList2: TStringList;

    iTogle: Integer;

  public
    { Public 錾 }

  end;

var
  FormExifShell: TFormExifShell;

implementation

uses
  Main;

{$R *.dfm}

function ItemSort1(Item1,Item2: TListItem; SortColumn: Integer): Integer; stdcall;
begin
  //\[gݒ
  case SortColumn of
    0:   Result := -lstrcmp(PChar(Item1.Caption),                PChar(Item2.Caption));
    else Result := -lstrcmp(PChar(Item1.SubItems[SortColumn-1]), PChar(Item2.SubItems[SortColumn-1]));
   end;
end;

function ItemSort2(Item1,Item2: TListItem; SortColumn: Integer): Integer; stdcall;
begin
  //\[gݒ
  case SortColumn of
    0:   Result :=  lstrcmp(PChar(Item1.Caption),                PChar(Item2.Caption));
    else Result :=  lstrcmp(PChar(Item1.SubItems[SortColumn-1]), PChar(Item2.SubItems[SortColumn-1]));
   end;
end;

procedure TFormExifShell.FormClose(Sender: TObject; var Action: TCloseAction);
var
  IniFile: TIniFile;
begin
  //ۑ
  if FormMain.bFormPositionSave = TRUE then
  begin
    MenuWindowPositionClick(Sender);
  end;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));

  //ݒ
  IniFile.WriteInteger('ExifShellListViewWidth',  '0',  ListView1.Columns[0].Width);
  IniFile.WriteInteger('ExifShellListViewWidth',  '1',  ListView1.Columns[1].Width);
  IniFile.WriteInteger('ExifShellListViewWidth',  '2',  ListView1.Columns[2].Width);
  IniFile.WriteInteger('ExifShellListViewWidth',  '3',  ListView1.Columns[3].Width);
  IniFile.WriteInteger('ExifShellListViewWidth',  '4',  ListView1.Columns[4].Width);

  //j
  IniFile.Free;

  //IMEIt
  SetImeMode(FormExifShell.Handle, imClose);

  //tH[JX߂
   FormMain.SetFocus;
end;

procedure TFormExifShell.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
;
end;

procedure TFormExifShell.FormCreate(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //m
  StrListExif := TStringList.Create;
  StrListPropaty := TStringList.Create;
  StrListCcr := TStringList.Create;
  CsvList2 := TStringList.Create;

  //
  Label1.Caption := '';
  Label2.Caption := '';

  //
  Memo1.Visible := FALSE;
  Memo1.Align := alClient;

  //
  ListView1.Columns.Add.Caption := EXIF_DATA_0;
  ListView1.Columns.Add.Caption := EXIF_DATA_1;
  ListView1.Columns.Add.Caption := EXIF_DATA_2;
  ListView1.Columns.Add.Caption := EXIF_DATA_3;
  ListView1.Columns.Add.Caption := EXIF_DATA_4;
  ListView1.ViewStyle := vsReport;
  ListView1.RowSelect := TRUE;
  ListView1.MultiSelect := FALSE;
  ListView1.Align := alClient;
  ListView1.Visible := TRUE;
  ListView1.ReadOnly := TRUE;

//  FALSE:tH[JXړĂc
//  D7  FALSE
//  XE2 TRUE
  ListView1.HideSelection := TRUE;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));

  //tH[ʒu
  FormPosLeft   := IniFile.ReadInteger('FormExifShell', 'Left',   0);
  FormPosTop    := IniFile.ReadInteger('FormExifShell', 'Top',    0);
  FormPosWidth  := IniFile.ReadInteger('FormExifShell', 'Width',  FORM_WIDTH_SET);
  FormPosHeight := IniFile.ReadInteger('FormExifShell', 'Height', FORM_HEIGHT_SET);
  StrFormState  := IniFile.ReadString ('FormExifShell', 'State',  FORM_NORMAL);
  FormPosRight  := FormPosLeft + FormPosWidth;
  FormPosButtom := FormPosTop  + FormPosHeight;

  //ݒ
  ListView1.Columns[ 0].Width := IniFile.ReadInteger('ExifShellListViewWidth',  '0', LIST_COLUM_WIDH_0);
  ListView1.Columns[ 1].Width := IniFile.ReadInteger('ExifShellListViewWidth',  '1', LIST_COLUM_WIDH_1);
  ListView1.Columns[ 2].Width := IniFile.ReadInteger('ExifShellListViewWidth',  '2', LIST_COLUM_WIDH_2);
  ListView1.Columns[ 3].Width := IniFile.ReadInteger('ExifShellListViewWidth',  '3', LIST_COLUM_WIDH_3);
  ListView1.Columns[ 4].Width := IniFile.ReadInteger('ExifShellListViewWidth',  '4', LIST_COLUM_WIDH_4);

  //j
  IniFile.Free;

end;

procedure TFormExifShell.FormDestroy(Sender: TObject);
begin
  //j
  StrListExif.Free;
  StrListPropaty.Free;
  StrListCcr.Free;
  CsvList2.Free;
end;

procedure TFormExifShell.FormShow(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //FormłȂ̂ŁACreatełȂShowōs
  //FormKeyDowñCxgݒ肷
  FormExifShell.KeyPreview := TRUE;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));

  //tH[ʒu
  FormPosLeft   := IniFile.ReadInteger('FormExifShell', 'Left',   0);
  FormPosTop    := IniFile.ReadInteger('FormExifShell', 'Top',    0);
  FormPosWidth  := IniFile.ReadInteger('FormExifShell', 'Width',  FORM_WIDTH_SET);
  FormPosHeight := IniFile.ReadInteger('FormExifShell', 'Height', FORM_HEIGHT_SET);
  StrFormState  := IniFile.ReadString ('FormExifShell', 'State',  FORM_NORMAL);
  FormPosRight  := FormPosLeft + FormPosWidth;
  FormPosButtom := FormPosTop  + FormPosHeight;


  //ݒ
  ListView1.Columns[ 0].Width := IniFile.ReadInteger('ExifShellListViewWidth',  '0', LIST_COLUM_WIDH_0);
  ListView1.Columns[ 1].Width := IniFile.ReadInteger('ExifShellListViewWidth',  '1', LIST_COLUM_WIDH_1);
  ListView1.Columns[ 2].Width := IniFile.ReadInteger('ExifShellListViewWidth',  '2', LIST_COLUM_WIDH_2);
  ListView1.Columns[ 3].Width := IniFile.ReadInteger('ExifShellListViewWidth',  '3', LIST_COLUM_WIDH_3);
  ListView1.Columns[ 4].Width := IniFile.ReadInteger('ExifShellListViewWidth',  '4', LIST_COLUM_WIDH_4);

  //j
  IniFile.Free;

  //GetSystemMetricst֐gpāCzʑŜ̃TCY擾
  MonitorTop    := GetSystemMetrics(SM_YVIRTUALSCREEN);
  MonitorLeft   := GetSystemMetrics(SM_XVIRTUALSCREEN);
  MonitorWidth  := GetSystemMetrics(SM_CXVIRTUALSCREEN);
  MonitorHeight := GetSystemMetrics(SM_CYVIRTUALSCREEN);
  MonitorRight  := MonitorLeft + MonitorWidth;
  MonitorButtom := MonitorTop  + MonitorHeight;

  //\ł ȌԂŕ\
  if ( (MonitorTop  <= FormPosTop  + FORM_TOP_SHIFT ) and (FormPosTop    <= MonitorButtom) ) and
     ( (MonitorTop  <= FormPosButtom                ) and (FormPosButtom <= MonitorButtom) ) and
     ( (MonitorLeft <= FormPosLeft + FORM_LEFT_SHIFT) and (FormPosLeft   <= MonitorRight ) ) and
     ( (MonitorLeft <= FormPosRight                 ) and (FormPosRight  <= MonitorRight ) ) then
  begin
    FormExifShell.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end
  //ʓɕ\łȂ ftHgŕ\
  else
  begin
    FormExifShell.SetBounds(0, 0 ,FORM_WIDTH_SET, FORM_HEIGHT_SET);
  end;

  //ő
  if StrFormState = FORM_MAX then
  begin
    FormExifShell.WindowState := wsMaximized;
  end
  //ŏ
  else if StrFormState = FORM_MIN then
  begin
    FormExifShell.WindowState := wsMinimized;
  end
  //W
  else
  begin
    //
  end;

  //IMEIt
  SetImeMode(FormExifShell.Handle, imClose);

end;

procedure TFormExifShell.FormResize(Sender: TObject);
begin
;
end;

procedure TFormExifShell.WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
begin
  //ŏTCY
  with msg.MinMaxInfo^.ptMinTrackSize do
  begin
    x := FORM_WIDTH_SET;
    y := FORM_HEIGHT_SET;
  end;
  //őTCY
  with msg.MinMaxInfo^.ptMaxTrackSize do
  begin
    //
  end;
  //ő剻TCY
  with msg.MinMaxInfo^.ptMaxSize do
  begin
    //
  end;
end;

procedure TFormExifShell.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
var
  iFunc1: Integer;
begin
  //@\擾
  GetFunction(FormMain.StrListKeyMain, iFunc1, Key, Shift);
  case iFunc1 of
    601 :  //I
      begin
        if FormMain.MenuExitEscape.Checked = TRUE then
        begin
          MenuQuitClick(Sender);
        end;
        key := 0;
      end;
    602 :  //I
      begin
        if FormMain.MenuExitKeyQ.Checked = TRUE then
        begin
          MenuQuitClick(Sender);
        end;
        key := 0;
      end;
  end;
end;

procedure TFormExifShell.FormKeyPress(Sender: TObject; var Key: Char);
begin
  //
  key := #0;
end;

procedure TFormExifShell.ListView1ColumnClick(Sender: TObject; Column: TListColumn);
begin
  //\[g̔]
  iTogle := (iTogle+1) mod 2;
  if iTogle = 0 then
  begin
    ListView1.CustomSort(@ItemSort2, Column.Index);
  end
  else
  begin
    ListView1.CustomSort(@ItemSort1, Column.Index);
  end;
end;

procedure TFormExifShell.MenuQuitClick(Sender: TObject);
begin
  //I
  Close;
end;

procedure TFormExifShell.MenuWindowPositionClick(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));

  //ʏ
  if WindowState = wsMaximized then
  begin
    IniFile.WriteString ('FormExifShell', 'State', FORM_MAX);
  end
  else if WindowState = wsMinimized then
  begin
    IniFile.WriteString ('FormExifShell', 'State', FORM_MIN);
  end
  else
  begin
    IniFile.WriteString ('FormExifShell', 'State', FORM_NORMAL);
    //ʃTCY
    IniFile.WriteInteger('FormExifShell', 'Left',   FormExifShell.Left);
    IniFile.WriteInteger('FormExifShell', 'Top',    FormExifShell.Top);
    IniFile.WriteInteger('FormExifShell', 'Width',  FormExifShell.Width);
    IniFile.WriteInteger('FormExifShell', 'Height', FormExifShell.Height);
  end;

  //j
  IniFile.Free;
end;



procedure TFormExifShell.GetValue(FileName: String; Sender: TObject);

var
  nItem: TListItem;
  sValue: String;
  iRow1: Integer;
  StrList1: TStringList;
  StrList2: TStringList;
  CsvList91: TStringList;
  CsvList92: TStringList;
  CsvList93: TStringList;
  SHFolder: Shell32_TLB.Folder;
  SHFolderItem: Shell32_TLB.FolderItem;
begin
  //
  Label2.Caption := '';
  Label1.Caption := ExtractFileName(FileName);

  //\Ȃ牽Ȃ
  if FormExifShell.Visible = FALSE then
  begin
    Exit;
  end;

  //NA
  ListView1.Items.BeginUpdate;
  ListView1.Items.Clear;
  ListView1.Items.EndUpdate;

  //m
  StrList1 := TStringList.Create;
  StrList2 := TStringList.Create;
  CsvList91 := TStringList.Create;
  CsvList92 := TStringList.Create;
  CsvList93 := TStringList.Create;

  //ݒ
  SHFolder     := Shell1.NameSpace  (ExtractFilePath(FileName));
  SHFolderItem := SHFolder.ParseName(ExtractFileName(FileName));

  //ڂ擾
  StrListPropaty.Clear;
  for iRow1 := 0 to 1000 do
  begin
    //\
    Label2.Caption := IntToStr(iRow1);
    Label2.Repaint;
    Application.ProcessMessages;
    //擾
    sValue := SHFolder.GetDetailsOf(varNull, iRow1);
    if sValue <> '' then
    begin
      StrListPropaty.Add(EXIF_DATA_0 + #09 + '#' + Format('%.4d',[iRow1]) + #09 + sValue)
    end;
  end;

  //擾
  for iRow1 := 0 to StrListPropaty.Count-1 do
  begin
    //\
    Label2.Caption := IntToStr(iRow1);
    Label2.Repaint;
    Application.ProcessMessages;
    //WJ
    CsvList91.Clear;
    StringToCsvList(StrListPropaty.Strings[iRow1], CsvList91);
    //vpeB
    if Copy(CsvList91[1], 1, 1) = '#' then
    begin
      sValue := SHFolder.GetDetailsOf(SHFolderItem,StrToInt(Copy(CsvList91[1], 2, 4)));
      if sValue <> '' then
      begin
        StrList1.Add(StrListPropaty.Strings[iRow1] + #09 + sValue);
      end;
    end;
   end;
  //ۑ
  StrList1.SaveToFile(ExtractFilePath(ParamStr(0)) + PROPATY_TXT);

  //\
  ListView1.Items.BeginUpdate;
  ListView1.Items.Clear;
  for iRow1 := 0 to StrList1.Count-1 do
  begin
    //WJ
    CsvList93.Clear;
    StringToCsvList(StrList1.Strings[iRow1], CsvList93);
    //1sݒ
    nItem := ListView1.Items.Add;
    nItem.Caption := CsvList93[0];
    ListView1.Items.Item[iRow1].SubItems.add(CsvList93[1]);
    ListView1.Items.Item[iRow1].SubItems.add(CsvList93[2]);
    ListView1.Items.Item[iRow1].SubItems.add(CsvList93[3]);
  end;
  ListView1.Items.EndUpdate;

  //j
  StrList1.Free;
  StrList2.Free;
  CsvList91.Free;
  CsvList92.Free;
  CsvList93.Free;
end;


procedure TFormExifShell.GetFunction(StrList: TStringList; var FunctionCode: Integer; var Key: Word; Shift: TShiftState);
var
  iRow1: Integer;
  iStatus: Integer;
begin
  //VtgԂ擾
  iStatus := 0;
  if (shift = [ssShift]) then
  begin
    iStatus := iStatus + 1;
  end;
  if (shift = [ssCtrl]) then
  begin
    iStatus := iStatus + 2;
  end;
  if (shift = [ssAlt]) then
  begin
    iStatus := iStatus + 4;
  end;

  //L[f[^XL
  FunctionCode := 0;
  for iRow1 := 0 to StrList.Count-1 do
  begin
    //L[f[^̊eڂ擾
    CsvList2.clear;
    StringToCsvList(StrList.Strings[iRow1], CsvList2);
    if iStatus = StrToInt(CsvList2[0]) then
    begin
      if key = StrToInt(CsvList2[2]) then
      begin
        FunctionCode := StrToInt(CsvList2[4]);
        Exit;
      end;
    end;
  end;
end;


end.

